/* @(#) escape.c  version:1.9  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.escape.c
 * SCCS id :	escape.c 1.9
 * Last edited:	10/19/84 13:59:33
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *		Frank van Steenbruggen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS1
#define GKS 1

#include "cgksincl.h"

extern GksState	gkstate;
extern Gks	*_gkss;
extern Gksd	*gksd;

Int ch_180();
Int ch_181();

escape(ef, ep)
Es_func ef;
Es_data *ep;
{
	Int	i;
	Wss	*ws;

	Ch_State(8, ESCP);

	if (ch_180(ef) != 0) GKS_RETURN(180)
	if (ch_181(ep) != 0) GKS_RETURN(181)

	/* call the driver for each active workstation
	 * having a non-NULL entry for the escape facility.
	 * at this moment
	 * if the escape function is not supported on this
	 * workstation, then that fact is detected by the driver,
	 * not here.
	 */
	i = 0;
	while ((ws = _gkss->gk_actv[i++]) != NULL) {
		if (WsScrn->s_escp != NULL)
			(*WsScrn->s_escp)(ws, ef, ep);
	}

	GKS_RETURN(0)
}

/*
 * if the specified function is not supported return 180
 * else return 0
 */
Int
ch_180(ef)
Es_func	ef;
{
	/*to do*/
	return(0);
}

/*
 * if the contents of the escape data record are invalid return 181
 * else return 0
 */
Int
ch_181(ep)
Es_data	*ep;
{
	/*to do*/
	return(0);
}
