/* @(#) fa_rep.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.fa_rep.c
 * SCCS id :	fa_rep.c 1.5
 * Last edited:	10/19/84 13:59:09
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 3
#define GKS3
#include "cgksincl.h"

extern Int	attmark[];
extern Gks	*_gkss;
extern Gksi	*gksis;

fa_rep(ws, fa)
Wss	*ws;
AreaRep	*fa;
{	AreaRep *ar;
	Int	nr = ws->ws_narea;
	Bindex	i = fa->fa_ix;

	Ch_State(7,S_FA_R);
	Ch_Er_Ws(ws,3 ,S_FA_R);

#ifdef METAFILE
	if (ws->ws_wsd->wd_cat == MO) {
		(*MfScrn->m_sfar)(ws,i,fa);
		return(0);
	}
#endif

	if  (fa->fa_ci >= ws->ws_ncolr) Rep_Er(86, S_FA_R);
	if  (fa->fa_is == PATTERN) {
		if (fa->fa_si < 1) Rep_Er(79, S_FA_R)
		/*  ... pattern_index fa->fa_si available in
			  ws->ws_pattern_table ? */
	}
	if  (fa->fa_is == HATCH) {
		Int	j = ws->ws_wsd->wd_nhatst;
		Sindex	*six = ws->ws_wsd->wd_hatst;
		while (j != 0){
			if (*six++ == fa->fa_si) break;
			j--;
		}
		if (j == 0) Rep_Er(80, S_FA_R);
	}

	ar = ws->ws_area;
	while (nr != 0 && ar->fa_ix != i) {
		nr--;
		ar++;
	}
	if (nr == 0) {
	     REALLOC(ws->ws_area, AreaRep, ws->ws_narea + 1, S_FA_R)
	     ar = ws->ws_area + ws->ws_narea;
	     ws->ws_narea++;
	}

	ASS(*ar , *fa)
	if (_gkss->gk_area == i) mark_ws(ws, WS_FAR);

	if ((ws->ws_wsd->wd_dmar & 010) != 0) { /*means IMM*/
		;/*nothing to do; arranged by device*/
	}
	else /* means IRG*/
	if (nr != 0) {
		/*not a good check to see if there are visible effects;
		 *add test to see if index in any visible segment
		 */
		newframe(ws, S_FA_R);
	}
	return(0);
}
