/* @(#) mf_contr.h  version:1.7  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mf_contr.h
 * SCCS id :	mf_contr.h 1.7
 * Last edited:	11/27/84 12:20:02
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/* 	metafile header	*/
#define HEADLN 90
STATIC 
Bool
m_hdr(ws)
Wss *ws;
{
	String str1 = "GKSM";
	String str2 = " and now something completely different ";
	String str3 = "00:00:00";

	Int	V, H, L, T, I, R, F, RI, ZERO, ONE;


	str1 = "GKSM";
	str2 = " and now something completely different ";

/*
 *	the current date is computed in the installation-
 *	dependent function to_day and written to the string
 *	str3
 */
	to_day(str3);


	V = 1;
	H = 4;
	L = 3;
	T = 3;
	F = 1;
	I = 6;
	R = 10;
	RI = 1;
	ZERO = 0;
	ONE = 1;

	store_mfhdr(ws, str1, str2, str3,
		V, H, T, L, I, R, F, RI, ZERO, ONE);
/*
 *	space is allocated for the string drecconst
 */

	MALLOC(drecconst,char,INTMAX*IBYTE + REALMAX*RBYTE + 1,O_WS)
}

/*
 *	function to construct the header of a metafile output
 *	from the strings s1, s2, s3 and the numbers V, ..., ONE
 */

store_mfhdr(ws, s1,s2, s3, V, H, T, L, I, R, F, RI, ZERO, ONE)
Wss *ws;
String	s1, s2, s3;
Int	V, H, L, T, I, R, F, RI, ZERO, ONE;
{
	char	c[HEADLN], *cptr;
	Int	i,is;

/*
 *	store info from all var in c[HEADLN]
 *	(first initialize on 0)
 */
	cptr = s1;
	i = 0;
	while (*cptr != '\0') c[i++] = *cptr++;

	cptr = s2;
	i = 4;
	while (*cptr != '\0') c[i++] = *cptr++;

	cptr = s3;
	i = 44;
	while (*cptr != '\0') c[i++] = *cptr++;

	int_in2bytes(V, &c[52]);
	int_in2bytes(H, &c[54]);
	int_in2bytes(L, &c[56]);
	int_in2bytes(T, &c[58]);
	int_in2bytes(I, &c[60]);
	int_in2bytes(R, &c[62]);
	int_in2bytes(F, &c[64]);
	int_in2bytes(RI, &c[66]);
	if (RI == 2) {
		real_in11bytes(ZERO, &c[68]);
		real_in11bytes(ONE, &c[79]);
	} else {
		for (i = 68; i<HEADLN; i++) c[i] = '-';
		ZERO = 0;
		ONE = 1;
	}

	cptr = &c[0];
	i = 0;
#if (MF_FORMAT == MFF_F77)
	position = 0;
#endif
	while (i < HEADLN) {
		putc(*cptr, Mofp);
		cptr++;
		i++;
#if (MF_FORMAT == MFF_F77)
#include "mf_newline.h"
#endif
	}
/*
 *	now, data from the header are stored in special
 *	fields of the ws internal statelist
 */

/*
 *	GKSM
 */

	i = 0;
	while (i < 4) {
		ws->ws_wsis->wi_mfhdr->mfh_GKSM[i] = c[i];
		i++;
	}
/*
 *	text string
 */
	i = 4;

	for (i = 4; i < 44; i++){
		is = i-4;
		ws->ws_wsis->wi_mfhdr->mfh_N[is] = c[i];
	}
/*
 *	the current date
 */
	i = 44;


	for (i = 44; i < 52; i++){
		is = i-44;
		ws->ws_wsis->wi_mfhdr->mfh_D[is] = c[i];
	}
/*
 *	within the include file mfhdrass.h,
 *	the format strings needed for reading and writing items
 *	are constructed from V, ..., ONE
 */

#include	"mfhdrass.h"

}

/*
 *	function to write integer to two byte string
 */
int_in2bytes(i, cptr)
Int	i;
char	*cptr;
{
	sprintf(cptr,"%2d",i);

}

/*
 *	function to write real to 11 byte string
 */
real_in11bytes()
{
	;
}

/*	end item	*/
STATIC
Bool 
m_clwk(ws)
Wss	*ws;
{
	Size lrec = 0;
	
	route_item(ws, M_CLWK, lrec, (char *)NULL);
/*
 *	end-of-line symbol is written to Metafile
 *	to close it properly
 */
	putc('\n',Mofp);

/*
 *	drecconst is released
 */
	FREE(drecconst)

}

/*		clear ws.;	 open ws.	*/
STATIC
Bool 
m_clrwk(ws,flag)
Wss	*ws;
Int	flag;
{

	idata[0] = flag;

	write_irdata(ws, M_CLRWK, idata, 1, rdata, 0);

}

/*	redraw all segments	*/
STATIC
Bool
m_rsgwk(ws)
Wss	*ws;
{
	
	route_item(ws, M_RSGWK, 0, (char *)NULL);
}

/*	update ws.;	 	*/
STATIC
Bool
m_uwk(ws,flag)
Wss	*ws;
Int flag;
{
	idata[0] = flag;

	write_irdata(ws, M_UWK, idata, 1, rdata, 0);

}

STATIC
Bool
m_sds	(ws,def,reg)	/*	set deferral state	*/
Wss	*ws;
Defmode	def;
Bool	reg;	/*SUPPRESSED = TRUE */
{

	idata[0] = (Int)def;
	idata[1] = (Int)reg;

	write_irdata(ws,M_SDS,idata,2,rdata,0);

}
/*
 *	message
 */
STATIC
Bool
m_msg	(ws,mess)	/* message */
Wss	*ws;
String	mess;
{
	Size lrec = 0;
	char	*datrec ;
	
	while (mess[lrec] != '\0') lrec++;
	datrec = (char *)mess;

	route_item(ws,M_MSG,lrec,datrec);

}


STATIC
Bool
m_esc	()	/*	escape	*/
{}
