/* @(#) mf_etcatt.h  version:1.4  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mf_etcatt.h
 * SCCS id :	mf_etcatt.h 1.4
 * Last edited:	11/27/84 12:20:15
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 *	set fillarea index
 */
STATIC
Bool m_sfai	(ws,i)
Wss *ws;
Bindex i;
{


	idata[0] = (Int)i;

	write_irdata(ws,M_SFAI,idata, 1, rdata, 0);

}

/*
 *	set fillarea interior style
 */
STATIC
Bool m_sfais	(ws,i)
Wss *ws;
Istyle i;
{


	idata[0] = (Int)i;

	write_irdata(ws,M_SFAIS,idata, 1, rdata, 0);

}

/*
 *	set fillarea style index
 */
STATIC
Bool m_sfasi	(ws,i)
Wss *ws;
Sindex i;
{


	idata[0] = (Int)i;

	write_irdata(ws,M_SFASI,idata, 1, rdata, 0);

}

/*
 *	set fillarea colour index
 */
STATIC 
Bool m_sfaci	(ws,i)
Wss *ws;
Cindex i;
{


	idata[0] = (Int)i;

	write_irdata(ws,M_SFACI,idata, 1, rdata, 0);

}

/*
 *	set  pattern sizes
 */
STATIC 
Bool m_spa	(ws,xps, yps)
Wss	*ws;
Nc	xps, yps;
{


	rdata[0] = xps.n_x;
	rdata[1] = xps.n_y;

	rdata[2] = yps.n_x;
	rdata[3] = yps.n_y;

	write_irdata(ws,M_SPA,idata, 0, rdata, 4);

}

/*
 *	set  pattern reference point
 */
STATIC 
Bool m_sparf	(ws,rp)
Wss	*ws;
Nc	rp;
{


	rdata[0] = rp.n_x;
	rdata[1] = rp.n_y;

	write_irdata(ws,M_SPARF,idata, 0, rdata, 2);

}

/*
 *	set aspect source flags
 */
STATIC 
Bool m_sasf	(ws,mask)
Wss	*ws;
Asflags	mask;
{
	Int i;
	Int div = 4096;
	Int imask = mask;
	Int num;


	for (i = 0; i<13; i++){
		num = imask/div;
		idata[i] = num;
		imask-=div*num;
		div/= 2;
	}

	write_irdata(ws,M_SASF,idata, 13, rdata, 0);

}

/*
 *	set pick identifier
 */
STATIC 
Bool m_spkid	(ws,id)	/* set pick identifier	*/
Wss *ws;
Pickid id;
{


	idata[0] = (Int)id;

	write_irdata(ws,M_SPKID,idata, 1, rdata, 0);

}
