/* @(#) mf_platt.h  version:1.5  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mf_platt.h
 * SCCS id :	mf_platt.h 1.5
 * Last edited:	11/27/84 12:20:22
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 *	set polyline index
 */
STATIC
Bool
m_spli(ws,i)
Wss *ws;
Bindex i;
{

	idata[0] = (Int)i;

	write_irdata(ws,M_SPLI,idata, 1, rdata, 0);

}
/*
 *	set line type
 */
STATIC
Bool
m_sln(ws,lt)
Wss *ws;
Ltype lt;
{
	idata[0] = (Int)lt;

	write_irdata(ws,M_SLN,idata, 1, rdata, 0);

}

/*
 *	set line width scale factor
 */
STATIC
Bool
m_slwsc(ws,lw)
Wss *ws;
Lwidth lw;
{
	rdata[0] = (Real)lw;

	write_irdata(ws,M_SLWSC,idata, 0, rdata, 1);

}


/*
 *	set polyline colour index
 */
STATIC
Bool
m_splci(ws,i)	
Wss *ws;
Cindex i;
{
	idata[0] = (Int)i;

	write_irdata(ws,M_SPLCI,idata, 1, rdata, 0);

}
