/* @(#) mf_txatt.h  version:1.4  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mf_txatt.h
 * SCCS id :	mf_txatt.h 1.4
 * Last edited:	11/27/84 12:24:33
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 *	set text index
 */

STATIC
Bool m_stxi	(ws,i)
Wss *ws;
Bindex i;
{


	idata[0] = (Int)i;

	write_irdata(ws,M_STXI,idata, 1, rdata, 0);

}

/*
 *	set text font and precision
 */
STATIC
Bool m_stxfp(ws,fopr)
Wss *ws;
FoPr	fopr;
{


	idata[0] = (Int)fopr.fp_fo;
	idata[1] = (Int)fopr.fp_pr;

	write_irdata(ws,M_STXFP,idata, 2, rdata, 0);

}
/*
 *	set character expansion factor
 */
STATIC
Bool m_schxp	(ws,ef)
Wss *ws;
Charef	ef;
{


	rdata[0] = (Real)ef;

	write_irdata(ws,M_SCHXP,idata, 0, rdata, 1);

}
/*
 *	set character spacing
 */
STATIC
Bool m_schsp	(ws,sp)
Wss *ws;
Charsp sp;
{



	rdata[0] = (Real)sp;

	write_irdata(ws,M_SCHSP,idata, 0, rdata, 1);

}

/*
 *	set text colour index
 */
STATIC 
Bool m_stxci	(ws,i)
Wss *ws;
Cindex i;
{


	idata[0] = (Int)i;

	write_irdata(ws,M_STXCI,idata, 1, rdata, 0);

}

/*
 *	set character vectors
 */
STATIC
Bool m_schup	(ws,v,ht)
Wss	*ws;
Nc	v;
Nc	ht;
{


	rdata[0] = v.n_x;
	rdata[1] = v.n_y;

	rdata[2] = ht.n_x;
	rdata[3] = ht.n_y;

	write_irdata(ws,M_SCHUP,idata, 0, rdata, 4);


}

/*
 *	set text path
 */
STATIC
Bool m_stxp	(ws,pt)
Wss *ws;
Path pt;
{


	idata[0] = (Int)pt;

	write_irdata(ws,M_STXP,idata, 1, rdata, 0);

}

/*
 *	set text alignment
 */
STATIC 
Bool m_stxal	(ws,ta)
Wss	*ws;
Talign	ta;
{


	idata[0] =(Int) ta.ta_hor;
	idata[1] =(Int) ta.ta_ver;

	write_irdata(ws,M_STXAL,idata, 2, rdata, 0);

}
