/* @(#) newseg.c  version:1.10  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.newseg.c
 * SCCS id :	newseg.c 1.10
 * Last edited:	10/19/84 13:57:02
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 5
#define GKS5
#define GKS3
#include	"cgksincl.h"

extern	Bhead	*lastbh;
extern	GksState gkstate;
extern	Gks	*_gkss;
extern	Gksi	*gksis;
extern	Gksd	*gksd;

#include	"newsegi.h"

/* CREATE SEGMENT */
Seg *
newseg(n)
Segname	n;
{	Seg	*seg;
	Int	i, ii;
	Wss	*ws;

	if (ch_state(3, CR_SG) != 0) return(NULL);
	if (ch_121(n, CR_SG) != 0) return(NULL);

	gkstate = SGOP;
	gksis->gki_sgact = TRUE;
	/* 
	 * implementation field to set segment in 
	 * state active or inactive
	 */ 

	MALLOC(seg, Seg, sizeof(Seg), CR_SG) 
	seg->sg_sn  = n;

	CALLOC(seg->sg_onws, Wss *, (gksd->gd_nwsas+1), CR_SG)
	/*
	 * initially calloc() fills the fields with NULL .
	 * 1 extra field is added to be sure always 1 field is NULL.
	 */

	i = 0;
	while (_gkss->gk_actv[i] != NULL) {
		seg->sg_onws[i] = _gkss->gk_actv[i++];
	}
	/* gksd->gd_nwsas is presumed to be not smaller
	 * than gksd->gd_nactv
	 */

	while (i < gksd->gd_nwsas) seg->sg_onws[i++] = NULL;

	s_idmatrix((Real *)(&(seg->sg_mat[0][0])));

	seg->sg_vis	= TRUE;
	seg->sg_hil	= FALSE;
	seg->sg_pri	= 0.0;
	seg->sg_det	= FALSE;
	seg->sg_firstbh = NULL;
	seg->sg_lastbh	= NULL;

	_gkss->gk_opsg = seg;


	i = 0;
	while ((ws =_gkss->gk_actv[i]) != NULL)  {
		if (ws->ws_wsd->wd_cat == MO) { ;
#ifdef METAFILE
			(*MfScrn->m_crsg)(ws,n);
#endif
		}
		insert_seg(&(_gkss->gk_actv[i++]->ws_segs), seg);
	}

	insert_seg(&(_gkss->gk_segs), seg);
	s_sgmarks();
	flg_in_seg();
	cl_mark(SG_ASF);
	ch_mark(SG_PID);

	return(seg);
}


/* CLOSE SEGMENT */
closeg()
{
#ifdef METAFILE
	Int i;

	Wss *ws;
	Seg *sg;
#endif

	Ch_State(4, CL_SG);
	gkstate = WSAC;

#ifdef METAFILE
	sg = _gkss->gk_opsg;
	for (i = 0; i<gksd->gd_nwsas; i++) {
		ws = sg->sg_onws[i];
		if (ws != NULL && ws->ws_wsd->wd_cat == MO) {
		/* only for MO ws ? */
			(*MfScrn->m_clsg)(ws);
		}

	}
#endif
	_gkss->gk_opsg->sg_lastbh = lastbh;
	_gkss->gk_opsg = NULL;
	lastbh = NULL;
	return(0);
}

act_seg()
{
	if (gkstate == SGOP)
		gksis->gki_sgact = TRUE;
}
deact_seg()
{
	if (gkstate == SGOP)
		gksis->gki_sgact = FALSE;
	/*now no more info is stored in segment although segment
	  is not yet closed */
}
