/* @(#) pa_rep.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.pa_rep.c
 * SCCS id :	pa_rep.c 1.5
 * Last edited:	10/19/84 13:56:14
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 3
#define GKS3
#include "cgksincl.h"

pa_rep(ws, pa)
Wss	*ws;
PattRep	*pa;
{
	Bindex	ix = pa->pa_ix;
	PattRep *pr;
	static	Int i;
	Int 	nr = ws->ws_npatt;
	Istyle	*is;
	Cindex 	*cipa = pa->pa_ci, *cipr;

	Ch_State(7, S_PN_R);
	Ch_Er_Ws(ws, 3, S_PN_R);

#ifdef METAFILE
	if (ws->ws_wsd->wd_cat == MO) {
		(*MfScrn->m_spar)(ws,ix,pa);
		return(0);
	}
#endif
	if (ix == 0) Rep_Er(79, S_PN_R);

	is = ws->ws_wsd->wd_istyl;
	i = ws->ws_wsd->wd_nistyl;
	while (i != 0) {
		if (*is == PATTERN) break;
		is++; i--;
	}
	if (i == 0) Rep_Er(83, S_PN_R);

	pr = ws->ws_patt;
	while (nr != 0 && pr->pa_ix != ix) {
		nr--;
		pr++;
	}
	if (nr == 0) {
		REALLOC(ws->ws_patt, PattRep, ws->ws_npatt + 1, S_PN_R)
		/*not neccessary to realloc colour arrays*/
		pr = ws->ws_patt + ws->ws_npatt;
		ws->ws_npatt++;
	}

	ASS(*pr, *pa)

	CALLOC(pr->pa_ci, Cindex, (pa->pa_n * pa->pa_m), S_PN_R)
	cipr = pr->pa_ci;
	for (i = 0; i < (pa->pa_n * pa->pa_m); i++ ) {
		*cipr = *cipa; 
		cipr++; cipa++;
	}
	/*now you can remove pa completely*/

	mark_ws(ws, WS_PAT);
	/*always! mark ws, even if current style index is not
	 *that of *pa
	 */

	if ((ws->ws_wsd->wd_dmar & 020) != 0) { /*means IMM*/
		;/*nothing to do; arranged by device*/
	}
	else /* means IRG*/
	if (nr != 0) {
		/*not a good check to see if there are visible effects;
		 *add test to see if index in any visible segment
		 */
		newframe(ws, S_PN_R);
	}
	return(0);
}
