/* @(#) rd_itm.c  version:1.4  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.rd_itm.c
 * SCCS id :	rd_itm.c 1.4
 * Last edited:	11/9/84 14:31:55
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */
/*
 *	read item data record
 */
#define GKS1
#define GKS7
#define GKS 7

#include	"mi_itp.h"

/*
 * read item data record from metafile input 
 */
rd_itm(ws,maxrec,datrec)
Wss	*ws;
Size	maxrec;
char	**datrec;
{
#ifdef METAFILE
	Int i = 0;
	Size lrec;
	char c;

	Ch_State(7,R_IT_GKSM);
	Ch_Er_Ws(ws,6,R_IT_GKSM);
	if (ws->ws_wsis->wi_miend == TRUE) Rep_Er(162,R_IT_GKSM);

	lrec = ws->ws_wsis->wi_item->it_hdr.ih_lngth;

/*

	if (maxrec > 0 && lrec > 0) {
		if (lrec > maxrec) {
			CALLOC(datrec,char*,maxrec,IP_IT_GKSM)
		} else {
			*datrec = (char *)calloc(lrec,sizeof(char));
		}
	}

*/
	ASS(ws->ws_wsis->wi_item->it_data , *datrec)

	if (lrec != 0) {

/*
 *		for (i = 0; i<lrec; i++) {
 *
 *			c = getc(Mifp);
 *			if (i < maxrec) {
 *				**datrec = c;
 *				(*datrec)++;
 *			}
 *		}
 */
 		while (i<lrec) {
 
 			c = getc(Mifp);
			if (c != '\n') {
 				if (i < maxrec) {
 					**datrec = c;
	 				(*datrec)++;
				}
				i++;
 			}
 		}
 
		(*datrec) -= lrec;
	}
#endif
}

#ifdef METAFILE

/*
*	utility function which returns a pointer to 
*	the workstation of category MI where the item of
*	given type, record size and pointer to data record
*	has been read ;
*	if no MI workstation can be found, a pointer to the
*	MI workstaion of highest rank is given, otherwise
*	a NULL pointer (no MI workstation open)
*/

Wss *
ws_mi_conn(type,lrec,datrec)

Itmtp	type;	/* item type	*/
Size	lrec;	/* data record size	*/
char	*datrec;	/* pointer to data record	*/
{
	Int i, last;
	Wss	*ws;

	for (i=0; i<gksd->gd_nopws; i++) {
		ws = _gkss->gk_opws[i];
		if (ws!= NULL && WCAT == MI) {
		    last = i;
		    if (lrec == ws->ws_wsis->wi_item->it_hdr.ih_lngth
			&& type == ws->ws_wsis->wi_item->it_hdr.ih_tp
			&& datrec == ws->ws_wsis->wi_item->it_data) {
				return(ws);
	   	    }
		}
	}
	
	if (last < gksd->gd_nopws) {
		return(_gkss->gk_opws[last]);
	}
	else {
		return(NULL);
	}
}
#endif /* METAFILE */

/* interpret item */

