/* @(#) renameseg.c  version:1.6  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.renameseg.c
 * SCCS id :	renameseg.c 1.6
 * Last edited:	10/19/84 13:54:42
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 5
#define GKS5
#include	"cgksincl.h"

extern Gks	*_gkss;
extern Gksd	*gksd;

/* RENAME SEGMENT */
renameseg(old, new)
Segname	old, new;
{
#ifdef METAFILE
	Int i;
	Wss *ws;
#endif
   	Seginst *si;

	Ch_State(7, RN_SG);
   	si = _gkss->gk_segs;
   	while (si != NULL && si->si_this->sg_sn != new)
      		si = si->si_next;
	if (si != NULL) Rep_Er(121, RN_SG)

   	si = _gkss->gk_segs;
   	while (si != NULL && si->si_this->sg_sn != old)
      		si = si->si_next;
	if (si == NULL) Rep_Er(122, RN_SG)
	else	si->si_this->sg_sn = new;

#ifdef METAFILE
	for (i = 0; i<gksd->gd_nwsas; i++){
		ws = si->si_this->sg_onws[i];
		if (ws != NULL && ws->ws_wsd->wd_cat == MO) {
			(*MfScrn->m_rensg)(ws,old,new);
		}
	}
#endif
	return(0);
}
