/* @(#) req_val.c  version:1.10  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.req_val.c
 * SCCS id :	req_val.c 1.10
 * Last edited:	11/19/84 19:26:29
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 6
#define GKS6
#include "cgksincl.h"

#define	BREAK	'\0'
#define	BACKSPACE '\010'

Bool	nc_in_nrect();
Bool	ic_in_drect();
Bool	newcurs();
extern	Gks	*_gkss;
extern	Gksi	*gksis;

#include "req_vali.h"

/* REQUEST VALUATOR */
Bool
req_val(ws,dn,val)
Wss	*ws;
Devno	dn;
Value	*val;
{
	register Idevice *idev = &(ws->ws_devs[2] [dn - 1]);
	Screen	*scr = WsScrn;
	Drect	*area = &(idev->id_area);
	Cindex	inpci = idev->id_drec.val_rec.val_col;
	Bool	inarea = FALSE, no_br = TRUE;
	Bool	firstchar = FALSE, numbers = FALSE, point = FALSE;
	Value	tmpval;
	Bool	hor;
	Ic	s, curs, curs0;
	Int	chx, chy;
	Int	mantisse = 0;
	Real	fac0, fac1, fac2;
	int	c;
	char	val_s[50];
	String	st = " ";
	
	if (ch_state(7, RQ_VAL) != 0) return(FALSE);
	if (ch_er_ws(ws, 7, RQ_VAL) != 0) return(FALSE);

	if (ch_devno(ws, VALUATOR, dn, RQ_VAL) != 0) return(FALSE);
	if (idev->id_mode != REQUEST)  {
		rep_er(141, RQ_VAL);
		return(FALSE);
	}

	ensure(RQ_VAL);
	ws_ensure(ws, RQ_VAL);

	fade_v_area(ws, idev, 0);
	show_v_area(ws,idev, idev->id_ival.ev_val); 


	switch(idev->id_pet) {
	case (3):
		tmpval = 0;
		chx = scr->s_chsz.i_x;
		chy = scr->s_chsz.i_y;
		curs0.i_x = area->d_ll.d_x + 1;
		curs0.i_y = area->d_ur.d_y - 1 - chy;
		ASS(curs, curs0)
		fac0 = 1;
		fac1 = 10;
		fac2 = 1;
		point = FALSE;
		firstchar = TRUE;

		while(mantisse < 6
		    && (c=(*WsScrn->s_inpk)(ws, &s, &curs)) != EOF
	     	    && (c != BREAK) && (c != '\n') ) 
		if ((c>= '0' && c <= '9') || 
		    (c == '-' && numbers == FALSE) ||
		    (c == '.' && point == FALSE)) {
			if (firstchar == TRUE) { 
			    Int i = 0;
			    if (scr->s_colr)
				(*scr->s_colr)(ws, 0);
			    sprintf((char *)val_s, "%f", *val);
			    while (val_s[i] != '\0') {
				st[0] = val_s[i++];
				(*scr->s_char)(ws, st, &curs);
				newcurs(1,&curs,&curs, area, chx, chy);
			    }
			    if (scr->s_colr) (*scr->s_colr)(ws, inpci);
			    ASS(curs , curs0)
			    firstchar = FALSE;
			}

			if (c == '-') fac0 *= -1;
	 		else if (c == '.') {
				point = TRUE;
				fac1 = 1;
				fac2 = 0.1;
				numbers = TRUE;
			}
			else {
			  tmpval = fac1 * tmpval + fac2 * ( c - '0');
			  if (fac2 < 1)  {
				fac2 *= 0.1;
				mantisse += 1;
			  }
			  numbers = TRUE;
			}

			st[0] = c;
			(*scr->s_char)(ws, st, &curs);
			newcurs(1,&curs, &curs, area, chx, chy);
		}

		if (c == BREAK) {
			no_br = FALSE;
			*val = 0.0;
		}
		else if (firstchar != TRUE){  
			*val = fac0 * tmpval ;
			if (*val < idev->id_drec.val_rec.val_min)
				*val = idev->id_drec.val_rec.val_min;
			else if (*val > idev->id_drec.val_rec.val_max)
				*val = idev->id_drec.val_rec.val_max;
		}
		break;

	case (1):
	default:
		hor =(Bool)((area->d_ur.d_x - area->d_ll.d_x) >=
			(area->d_ur.d_y - area->d_ll.d_y)); 
		while (inarea == FALSE) {
			if ((*WsScrn->s_inpc)(ws, &s, 0) == BREAK) {
				no_br = FALSE;
				break;
			}
			inarea = ic_in_drect(area, &s);
		}
		if (no_br) {
			if (hor) {
				*val = (s.i_x - area->d_ll.d_x) /
			    	   (area->d_ur.d_x - area->d_ll.d_x); 
			}
			else {
				*val = (s.i_y - area->d_ll.d_y) /
			    	   (area->d_ur.d_y - area->d_ll.d_y); 
			}
		}
		break;
	}
	
	if (no_br == FALSE) 
		fade_v_area(ws, idev, *val);
	else if (idev->id_echo == TRUE) 
		show_v_area(ws, idev, *val);

	return(no_br);
}
