/* @(#) s_ch_ht.c  version:1.7  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.s_ch_ht.c
 * SCCS id :	s_ch_ht.c 1.7
 * Last edited:	10/19/84 13:52:50
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS3
#define GKS 3
#include "cgksincl.h"

extern Gksi	*gksis;
extern Gksd	*gksd;
extern Gks	*_gkss;
extern GksState	gkstate;

s_ch_ht(ht)
Charht ht;
{	Ch_State(8, S_CHT);
	if (_gkss->gk_chht != ht) {
		_gkss->gk_chht = ht;
#ifdef METAFILE

/*
 *	normalized char. height/width vectors are routed
 *	to metafiles
 */
		mf_chhtup();
#endif
		ch_mark(SG_CHV);
		if (gkstate == SGOP) tr_mark(SG_TXI);
	}
	return(0);
}
#ifdef METAFILE
mf_chhtup()
{
	Int i;
	Wss *ws;
	Real x, y, labda;
	Wc wht;

/*
*	normalization transformations of character height
*	and width vector are performed
*/
	setcurmat(_gkss->gk_curnt);

	x = _gkss->gk_chup.w_x;
	y = _gkss->gk_chup.w_y;
	labda = _gkss->gk_chht / 
		sqrt((double)(x * x + y * y));
	wht.w_x = labda * x;
	wht.w_y = labda * y;
	scale(gksis->gki_mat, &wht, &gksis->gki_chvec);
	wht.w_x = labda * y; 
	wht.w_y = labda * x * -1.0;
	scale(gksis->gki_mat, &wht, &gksis->gki_cwvec);

	for (i = 0; i< gksd->gd_nactv; i++){
		if ((ws = _gkss->gk_actv[i]) != NULL) {
			if (ws->ws_wsd->wd_cat == MO) {
				(*MfScrn->m_schup)(ws,
				gksis->gki_chvec,gksis->gki_cwvec);
			}
		}
	}
}
#endif

