/* @(#) s_patsiz.c  version:1.6  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.s_patsiz.c
 * SCCS id :	s_patsiz.c 1.6
 * Last edited:	10/19/84 13:51:11
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS3
#define GKS 3
#include "cgksincl.h"

extern Gks	*_gkss;
extern Gksi	*gksis;
extern Gksd	*gksd;

s_patsiz(sz)
Wc sz;
{	Ch_State(8, S_PASZ);
	if (_gkss->gk_patsiz.w_x != sz.w_x ||
	    _gkss->gk_patsiz.w_y != sz.w_y) {
		ASS(_gkss->gk_patsiz, sz)
#ifdef METAFILE
		/* item is sent to active workstations of category MO */
		mf_patsiz();
#endif
		ch_mark(SG_PASZ);
	}
	return(0);
}


#ifdef METAFILE
/*
*	function to route scaled pattern sizes to Metafile
*/
mf_patsiz()
{
	Int i = 0;
	Wss *ws;

	gksis->gki_xpatsiz.n_x =
	    _gkss->gk_patsiz.w_x * gksis->gki_mat[0][0];
	gksis->gki_xpatsiz.n_y = 0.0;

	gksis->gki_ypatsiz.n_x = 0.0;
	gksis->gki_ypatsiz.n_y =
	    _gkss->gk_patsiz.w_y * gksis->gki_mat[1][1];

	while ((ws = _gkss->gk_actv[i++]) != NULL) {
		if (ws->ws_wsd->wd_cat == MO) {
			(*MfScrn->m_spa)(ws,gksis->gki_xpatsiz,
					gksis->gki_ypatsiz);
		}
	}
}
#endif
