/* @(#) s_vip.c  version:1.4  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.s_vip.c
 * SCCS id :	s_vip.c 1.4
 * Last edited:	10/19/84 13:49:02
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 4
#define GKS4

#include "cgksincl.h"

extern	Gks	*_gkss;
extern	Gksi	*gksis;

s_vip(nt, rnt, hi)
Ntran	*nt, *rnt;
Bool	hi;
{	Int	i, j, t_nr, rt_nr;
	Int	*tmp, *tnr_ptr, *rtnr_ptr;
	Ntran	**ad_nt, **ad_rnt;
	
	Ch_State(8, S_VIP);

	if (nt == rnt) return(0); 

	t_nr = rt_nr = 0;
	ad_nt  = &_gkss->gk_ntran[0];
	while (*ad_nt++ != nt) t_nr++;
	ad_rnt = &_gkss->gk_ntran[0];
	while (*ad_rnt++ != rnt) rt_nr++;

	tnr_ptr = &(gksis->gki_ntp[0]);
	while (*tnr_ptr != t_nr) tnr_ptr++;
	rtnr_ptr = &(gksis->gki_ntp[0]);
	while (*rtnr_ptr != rt_nr) rtnr_ptr++;

	if (tnr_ptr > rtnr_ptr)	{ i = -1;
				j = (hi) ? 0 : 1;
	}
	else			{ i = 1;
				j = (hi) ? -1 : 0;
	}

	while (tnr_ptr != (rtnr_ptr + j)) {
		tmp = tnr_ptr + i;
		*tnr_ptr = *tmp;
		tnr_ptr  = tnr_ptr + i;
	}
	*tnr_ptr = t_nr;
	return(0);
}
