/* @(#) sendseg.c  version:1.7  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.sendseg.c
 * SCCS id :	sendseg.c 1.7
 * Last edited:	11/27/84 12:39:30
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/* ASSOCIATE SEG. WITH W.S.
 * level 2a 
 */

#define GKS 5
#define GKS5
#include	"cgksincl.h"

extern	Gks	*_gkss;
extern	Gksd	*gksd;


sendseg(ws,seg)
Wss	*ws;
Seg	*seg;
{
	Seginst	*wssegs;
	Int 	i = 0;

	Ch_State(6, AS_SG_WS);
	Ch_Er_Ws(ws, 4, AS_SG_WS);
	if (ch_122(seg, AS_SG_WS) != 0) return(122);
	if (ch_124(seg, AS_SG_WS) != 0) return(124);

	wssegs = ws->ws_segs;
	while (wssegs != NULL && wssegs->si_this != seg) 
		wssegs = wssegs->si_next;
	if (wssegs == NULL) {
		insert_seg(&(ws->ws_segs), seg);
		i = 0;
		while (i < gksd->gd_nactv &&
			seg->sg_onws[i] != NULL) i++;
		if (i < gksd->gd_nactv) 
			seg->sg_onws[i] = ws;
	}
	/*else no effect*/
#ifdef METAFILE
/*
 * if the ws is of category MO, the following actions have 
 * to be performed:
 * 	1) the OPEN SEGMENT item is sent to the ws;
 *	2) all the SEGMENT ATTRIBUTE items are sent to the ws.
 *	3) all the items of the segment's contents are sent to the ws.
 *	4) the CLOSE SEGMENT item is sent to the ws;
 */

	if (ws->ws_wsd->wd_cat == MO) {
		(*MfScrn->m_crsg)(ws,seg->sg_sn);

		(*MfScrn->m_ssgt)(ws,seg->sg_sn,seg->sg_mat);
		(*MfScrn->m_svis)(ws,seg->sg_sn,seg->sg_vis);
		(*MfScrn->m_shlit)(ws,seg->sg_sn,seg->sg_hil);
		(*MfScrn->m_ssgp)(ws,seg->sg_sn,seg->sg_pri);
		(*MfScrn->m_sdtec)(ws,seg->sg_sn,seg->sg_det);

		drawsegonws(ws,seg,AS_SG_WS);

		(*MfScrn->m_clsg)(ws);
	}
#endif

	return(0);
}
	
int
ch_124(seg, rout)
Seg	*seg;
Int	rout;
{
	Seginst	*wisssegs;
	Wss	*wiss;
	Int	i = 0;

	while (_gkss->gk_opws[i]->ws_wsd->wd_cat != WISS)
			i++;
	/* existence of WISS already checked in ch_er_ws() */
	wiss = _gkss->gk_opws[i];

	wisssegs = wiss->ws_segs;
	while (wisssegs != NULL && wisssegs->si_this != seg)
		wisssegs = wisssegs->si_next;
	if (wisssegs == NULL) {
		rep_er(124, rout);
		return(124);
	}
	else return(0);
}
