/* @(#) u_itpcontr.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_itpcontr.c
 * SCCS id :	u_itpcontr.c 1.5
 * Last edited:	11/9/84 15:36:42
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */
#define GKS1
#define GKS7
#define GKS 7

#include	"mi_itp.h"
#ifdef METAFILE

/*
 *	end item
 */
i_clwk	(lrec,datrec)
Size lrec;
char **datrec;
{
}

/*
 *	 clear ws.;
 */
i_clrwk	(lrec,datrec)
Size lrec ;
char	**datrec;
{
	Bool	flag;
	Int i;
	Wss *ws;

	GET_INT(flag,datrec,Bool)

	for (i = 0; i < gksd->gd_nactv; i++){
		if ((ws = _gkss->gk_actv[i])!=NULL){
			clear(ws,flag);
		}
	}
}

/*
 *	redraw all segments on ws
 */
i_rsgwk	 (lrec,datrec)
Size lrec ;
char	**datrec;
{
	Int i;
	Wss *ws;

	for (i = 0; i < gksd->gd_nactv; i++){
		if ((ws = _gkss->gk_actv[i])!=NULL){
			if (WCAT != WISS){
				redraw(ws);
			}
		}
	}
}

/*
 *	update ws.;
 */
i_uwk(lrec,datrec)
Size lrec ;
char	**datrec;
{
	Bool flag;
	Int i;
	Wss *ws;

	GET_INT(flag,datrec,Bool)

	for (i=0; i<gksd->gd_nactv; i++){
		if ((ws = _gkss->gk_actv[i]) != NULL) {
			if (WCAT != WISS){
				update(ws,flag);
			}
		}
	}
}

/*
 *	set deferral state
 */
i_sds	(lrec,datrec)
Size lrec;
char **datrec;
{
	Bool reg;
	Defmode def;
	Int i;
	Wss *ws;

	GET_INT(reg,datrec,Bool)
	GET_INT(def,datrec,Defmode)

	for (i=0; i<gksd->gd_nactv; i++){
		if ((ws = _gkss->gk_actv[i]) != NULL) {
			if (WCAT != WISS){
				s_defer(ws,def,reg);
			}
		}
	}
}

/*
 *	message	
 */
i_msg	(lrec,datrec)
Size lrec;
char **datrec;
{
	Int i;
	String text;
	Wss *ws;

	CALLOC(text,char,1+lrec,MESS)

	for (i = 0; i<=lrec; i++){
		text[i] = datrec[0][i];
	}

	text[lrec] = '\0';

	for (i=0; i<gksd->gd_nactv; i++){
		if ((ws = _gkss->gk_actv[i]) != NULL) {
			if (WCAT != WISS){
				message(ws,text);
			}
		}
	}

}

i_esc	(lrec,datrec)	/*	escape	*/
Size lrec;
char **datrec;
{}

#else 
static int dummy; /* to force creation of a symble table (for ranlib) */
#endif /*METAFILE */
