/* @(#) u_itppmatt.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_itppmatt.c
 * SCCS id :	u_itppmatt.c 1.5
 * Last edited:	11/9/84 15:36:59
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS3
#define GKS7

#include	"mi_itp.h"

#ifdef METAFILE

/*
 *	set polymarker index
 */
i_spmi(lrec,datrec)
char **datrec;
Size lrec;
{
	Bindex i;

	GET_INT(i,datrec,Bindex)

	s_pm_i(i);
}

/*
 *	set marker type
 */
i_smk(lrec,datrec)
char **datrec;
Size lrec;
{
	Mtype mt;

	GET_INT(mt,datrec,Mtype)

	s_mt(mt);
}

/*
 *	set markersize scale factor
 */
i_smksc(lrec,datrec)
char **datrec;
Size lrec;
{
	Msize ms;

	GET_REAL(ms,datrec,Msize)

	s_msz(ms);
}

/*
 *	set polymarker colour index
 */
i_spmci(lrec,datrec)
char **datrec;
Size lrec;
{
	Cindex i;

	GET_INT(i,datrec,Cindex)

	s_pm_ci(i);
}

#else 
static int dummy; /* to force creation of a symble table (for ranlib) */
#endif /*METAFILE */
