/* @(#) u_itptrans.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_itptrans.c
 * SCCS id :	u_itptrans.c 1.5
 * Last edited:	11/9/84 15:37:14
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS7

#include	"mi_itp.h"

#ifdef METAFILE

extern	Int attmark[];

/*
 *	set clipping rectangle
 */
i_sclpr	(lrec,datrec)
Size lrec;
char **datrec;
{
	Nrect clipr;
	Wrect unit;
	Ntran nt;	

	unit.w_ll.w_x = unit.w_ll.w_y = 0.0;
	unit.w_ur.w_x = unit.w_ur.w_y = 1.0;

	GET_REAL(clipr.n_ll.n_x,datrec,Real)
	GET_REAL(clipr.n_ur.n_x,datrec,Real)

	GET_REAL(clipr.n_ll.n_y,datrec,Real)
	GET_REAL(clipr.n_ur.n_y,datrec,Real)

	_gkss->gk_curnt->nt_wind =  unit;
	_gkss->gk_curnt->nt_view = clipr;

	if (	clipr.n_ll.n_x == 0.0 &&
		clipr.n_ll.n_y == 0.0 &&
		clipr.n_ur.n_x == 1.0 &&
		clipr.n_ur.n_y == 1.0) {
		_gkss->gk_clip = FALSE;
	} else {
		_gkss->gk_clip = TRUE;
	}
	ch_mark(SG_CLP);
	msk_openws(WS_CLP);

	setcurmat(_gkss->gk_curnt);

	MF_ATTENSURE(m_sclpr,gk_curnt->nt_view)
}

/*
 *	set workstation window
 */
i_swkwn	(lrec,datrec)
Int lrec;
char **datrec;
{
	Int i;
	Wss *ws;
	Nrect	nr;

	GET_REAL(nr.n_ll.n_x,datrec,Real)
	GET_REAL(nr.n_ur.n_x,datrec,Real)

	GET_REAL(nr.n_ll.n_y,datrec,Real)
	GET_REAL(nr.n_ur.n_y,datrec,Real)

	for (i = 0; i<gksd->gd_nopws; i++) {
		ws = _gkss->gk_opws[i];
		if (ws != NULL && WCAT != MI && WCAT != WISS)
		s_w_wind(ws,&nr);
	}
}

/*
 *	set workstation viewport
 */
i_swkvp	(lrec,datrec)	
Int lrec;
char **datrec;
{
	Int i;
	Wss *ws;
	Drect	dr;

	GET_REAL(dr.d_ll.d_x,datrec,Real)
	GET_REAL(dr.d_ur.d_x,datrec,Real)

	GET_REAL(dr.d_ll.d_y,datrec,Real)
	GET_REAL(dr.d_ur.d_y,datrec,Real)

	for (i = 0; i<gksd->gd_nopws; i++) {
		ws = _gkss->gk_opws[i];
		if (ws != NULL && WCAT != MI && WCAT != WISS)
		s_w_view(ws,&dr);
	}
}

#else 
static int dummy; /* to force creation of a symble table (for ranlib) */
#endif /*METAFILE */
