/* @(#) u_itptxtatt.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_itptxtatt.c
 * SCCS id :	u_itptxtatt.c 1.5
 * Last edited:	11/9/84 15:37:19
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define	GKS7
#define	GKS 3

#include "mi_itp.h"

#ifdef METAFILE

extern Int attmark[];
/*
 *	set text index
 */
i_stxi	(lrec,datrec)
Size lrec;
char **datrec;
{
	Bindex i;

	GET_INT(i,datrec,Bindex)

	s_tx_i(i);
}

/*
 *	set text font and precision
 */
i_stxfp	(lrec,datrec)
Size lrec;
char **datrec;
{
	FoPr pp;

	GET_INT(pp.fp_fo,datrec,Tfont)
	GET_INT(pp.fp_pr,datrec,Tprec)

	s_tx_fp(pp);
}

/*
 *	set character exppansion factor
 */
i_schxp	(lrec,datrec)
Size lrec;
char **datrec;
{
	Charef ef;

	GET_REAL(ef,datrec,Charef)

	s_ch_ef(ef);
}

/*
 *	set character spacing
 */
i_schsp	(lrec,datrec)
Size lrec;
char **datrec;
{
	Charsp sp;

	GET_REAL(sp,datrec,Charsp)

	s_ch_sp(sp);
}
/*
 *	set text colour index
 */
i_stxci	(lrec,datrec)
Size lrec;
char **datrec;
{
	Cindex i;

	GET_INT(i,datrec,Cindex)

	s_tx_ci(i);
}

/*
 *	set character height/width vectors
 */
i_schup	(lrec,datrec)	
Size lrec;
char **datrec;
{
	Int i;
	Wss *ws;

	Nc chvec, cwvec;

	GET_REAL(chvec.n_x,datrec,Real)
	GET_REAL(chvec.n_y,datrec,Real)

	GET_REAL(cwvec.n_x,datrec,Real)
	GET_REAL(cwvec.n_y,datrec,Real)

	if (	chvec.n_x != gksis->gki_chvec.n_x ||
		chvec.n_y != gksis->gki_chvec.n_y ||
		cwvec.n_x != gksis->gki_cwvec.n_x ||
		cwvec.n_y != gksis->gki_cwvec.n_y ) {

		gksis->gki_chvec = chvec;
		gksis->gki_cwvec = cwvec;

		tr_mark(TXATT);
		ch_mark(SG_CHV);
		if (gkstate == SGOP) tr_mark(SG_TXI);
	}

/*
 *	character vectors are routed to active ws.
 *	of category MO
 */
	for (i = 0; i< gksd->gd_nactv; i++){
		if ((ws = _gkss->gk_actv[i]) != NULL) {
			if (ws->ws_wsd->wd_cat == MO) {
				(*MfScrn->m_schup)(ws,
				gksis->gki_chvec,gksis->gki_cwvec);
			}
		}
	}
}

/*
 *	set text path
 */
i_stxp	(lrec,datrec)
Size lrec;
char **datrec;
{
	Path pt;

	GET_INT(pt,datrec,Path)

	s_tx_pt(pt);
}
 
/*
 *	set text alignment
 */
i_stxal	(lrec,datrec)	/*	set text alignment	*/
Size lrec;
char **datrec;
{
	Talign ta;

	GET_INT(ta.ta_hor,datrec,Talhor)
	GET_INT(ta.ta_ver,datrec,Talver)

	s_tx_al(ta);
}

#else 
static int dummy; /* to force creation of a symble table (for ranlib) */
#endif /*METAFILE */
