/* @(#) u_mihdr.c  version:1.7  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_mihdr.c
 * SCCS id :	u_mihdr.c 1.7
 * Last edited:	11/15/84 13:25:30
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
/* 	metafile header	
 */
#define GKS1
#define GKS7
#define GKS 7

#include	"mi_itp.h"

#ifdef METAFILE

extern Fun pmi_hdr; /* declred in open_ws.c */


Int IBYT;
Int RBYT;
#define RECLEN 90

/* 	metafile header	*/

mi_hdr(ws)
Wss *ws;
{
	Int	V, H, L, T, I, R, F, RI, ZERO, ONE;

	char	ch, c[RECLEN]; 
	Int	i, is;

/*
 *	read c[RECLEN] from metafile
 */
	i = 0;
 
	while (i<RECLEN) {
		ch = getc(Mifp);
		if (ch != '\n') {
			c[i] = ch;
			i++;
		}
	}
	i = 0;
	while (i < 4) {
		ws->ws_wsis->wi_mfhdr->mfh_GKSM[i] = c[i];
		i++;
	}


	i = 4;

	for (i = 4; i < 44; i++){
		is = i-4;
		ws->ws_wsis->wi_mfhdr->mfh_N[is] = c[i];
	}
	i = 44;


	for (i = 44; i < 52; i++){
		is = i-44;
		ws->ws_wsis->wi_mfhdr->mfh_D[is] = c[i];
	}

	int_out2bytes(&V, &c[52]);
	int_out2bytes(&H, &c[54]);
	int_out2bytes(&L, &c[56]);
	int_out2bytes(&T, &c[58]);
	int_out2bytes(&I, &c[60]);
	int_out2bytes(&R, &c[62]);
	int_out2bytes(&F, &c[64]);
	int_out2bytes(&RI, &c[66]);

	if (RI == 2) {
		real_out11bytes(ZERO, &c[68]);
		real_out11bytes(ONE, &c[79]);
	}
	else {
		ZERO = 0;
		ONE = 1;
	}

#include	"mfhdrass.h"

	IBYT = IBYTE;
	RBYT = RBYTE;

	ws->ws_wsis->wi_miend = FALSE;
}

/* 
 * sf_mihdr() is called in mi() (see mi_drive.c).
 * now if pmi_hdr() is called in open_ws() then mi_hdr() is executed.
 */
sf_mihdr()
{
	pmi_hdr = mi_hdr;
}


int_out2bytes(i, cptr)
Int	*i;
char	*cptr;
{

	Int high, low, j;
	static char ff[] = "   \0";

	ff[0] = *cptr;
	ff[1] = *(cptr+1);

	*i = atoi(ff);
}

real_out11bytes(lrec,datrec)
{
}

#else 
static int dummy; /* to force creation of a symble table (for ranlib) */
#endif /*METAFILE */
