/* @(#) u_sgblck.c  version:1.4  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_sgblck.c
 * SCCS id :	u_sgblck.c 1.4
 * Last edited:	10/19/84 13:42:32
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/* This file contains utility functions for the GKS outputfunctions*/

#define GKS 2
#define GKS1
#define GKS2
#define GKS8

#include "cgksincl.h"

Nc	*sg_sp_pr();
char	*seg_block();

extern	Int	attmark[];
extern	Nrect	ndc;
extern	GksState gkstate;
extern	Gks	*_gkss;
extern	Gksi	*gksis;
extern	Bhead	*lastbh;

/*
 * provide a block of storage preceded by a seg header 
 */
char *
seg_block(size, type, l)
Size size, l;
Int type;
{	Bhead	*bh;
	Int	sz = sizeof(Bhead) + l * size;
	MALLOC(bh, Bhead, sz, SG_BL)
	if (gkstate == SGOP && gksis->gki_sgact == TRUE) {
		if (lastbh != NULL) {
			lastbh->sb_link = bh;
			lastbh = bh;
		}
		else {	_gkss->gk_opsg->sg_firstbh = bh;
			lastbh = bh;
		}
	}

	bh->sb_typ = type;
	bh->sb_sz = l * size;
	bh->sb_link = NULL;
	return ((char *)++bh);
}

fr_sgblock(pr)
char	*pr;
{	Bhead *bh;
	if (gkstate != SGOP ||
	    (gkstate == SGOP && gksis->gki_sgact == FALSE)) {
		bh = (Bhead *)pr;
		--bh;
		FREE(bh) /*sufficient ?*/
	}
}


Nc *
sg_sp_pr(n, prt)
Size	n;
Int	prt;
{	Nc	*pr;
	pr = (Nc *) seg_block(sizeof(Nc), prt, n);
	return (pr);
}
