/* @(#) verpmk.h  version:1.4  dated:84/11/20 */
/*
 * SCCS file:	SCCS/s.verpmk.h
 * SCCS id :	verpmk.h 1.4
 * Last edited:	10/19/84 13:39:19
 */

/**********************POLYMARK*********************/
STATIC
dr_dot(ws, s, msize , eras)
Wss	*ws;
Bool	eras;
Msize	msize;
Ic	*s;
{
	moveto(s);
	point((int)s->i_x, (int)s->i_y);
}

STATIC
dr_circle(ws, s, msize , eras)
Wss	*ws;
Msize	msize;
Bool	eras;
Ic	*s;
{	Int radius = (Int)(msize * CHARX * 0.4);
	moveto(s);
	circle((int)s->i_x, (int)s->i_y, (int)radius);
}

STATIC
mk_line(ws, scr, fromx, fromy, tox, toy)
Wss	*ws;
Screen	*scr;
Int	fromx, fromy, tox, toy;
{	Ic ic[2];
	ic[0].i_x = fromx; ic[0].i_y = fromy;
	ic[1].i_x = tox;   ic[1].i_y = toy;
	(*scr->s_line)(ws, 2, ic, SOLIDL, 1);
}

STATIC
dr_plus(ws, s, msize )
Wss	*ws;
Msize	msize;
Ic	*s;
{	register Int sz = (Int) (0.4 * msize * CHARX);
	Screen *scr = WsScrn;

	mk_line(ws, scr, s->i_x - sz, s->i_y, s->i_x + sz, s->i_y);
	mk_line(ws, scr, s->i_x, s->i_y - sz, s->i_x, s->i_y + sz);
}

STATIC
dr_asterisk(ws, s, msize )
Wss	*ws;
Msize	msize;
Ic	*s;
{	register Int sz = (Int)(0.4 * msize * CHARX);
	Screen *scr = WsScrn;
	register Int	up;

	up = (Int)(sz / sqrt(2.0));
	mk_line(ws, scr, s->i_x - sz, s->i_y, s->i_x + sz, s->i_y);
	mk_line(ws, scr, s->i_x, s->i_y - sz, s->i_x, s->i_y + sz);
	mk_line(ws, scr, s->i_x-up, s->i_y-up, s->i_x+up, s->i_y+up);
	mk_line(ws, scr, s->i_x+up, s->i_y-up, s->i_x-up, s->i_y+up);
}

static
dr_cross (ws, s, msize )
Wss	*ws;
Msize	msize;
Ic	*s;
{	register Int sz = (Int)(0.8 * msize * CHARX) / 2;
	Screen *scr = WsScrn;

	mk_line(ws, scr, s->i_x+sz, s->i_y+sz, s->i_x-sz, s->i_y-sz);
	mk_line(ws, scr, s->i_x+sz, s->i_y-sz, s->i_x-sz, s->i_y+sz);
}

Fun pmarkfv[] = {dr_dot, dr_plus, dr_asterisk, dr_circle, dr_cross};

STATIC
Bool drawmark(ws, n, s, ms, mt, eras)
Wss	*ws;
Size	n;
Ic	*s;
Bool	eras;
Msize	ms;
Mtype	mt;
{
	while (n--)
		(*pmarkfv[mt-1])(ws, s++, ms, eras);
}
