/* @(#) col_rep.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.col_rep.c
 * SCCS id :	col_rep.c 1.5
 * Last edited:	10/19/84 14:00:38
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 3
#define GKS3
#include "cgksincl.h"

extern Gks	*_gkss;
extern Gksi	*gksis;

col_rep(ws, ci, col)
Wss *ws;
Cindex ci;
Colour *col;
{
	Ch_State(7, S_CO_R);
	Ch_Er_Ws(ws, 3 , S_CO_R);

#ifdef METAFILE
	if (ws->ws_wsd->wd_cat == MO) {
		(*MfScrn->m_scr)(ws,ci,col);
		return(0);
	}
#endif
	if(ci >= ws->ws_wsd->wd_ncix) Rep_Er(86, S_CO_R);

	if (col->c_red   > 1.0 ||
	    col->c_green > 1.0 ||
	    col->c_blue  > 1.0 )
		Rep_Er(88, S_CO_R);

	ASS(ws->ws_colr[ci], *col)
	mark_ws(ws, WS_COL);

	if ((ws->ws_wsd->wd_dmar & 040) != 0) { /*means IMM*/
		;/*nothing to do; arranged by device*/
	}
	else /* means IRG*/ {
		/*add test to see if index in any visible segment
		 */
		newframe(ws, S_CO_R);
	}
	return(0);
}
