/* @(#) er_hand.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.er_hand.c
 * SCCS id :	er_hand.c 1.5
 * Last edited:	11/19/84 18:42:31
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS10
#define GKS 10

#include "cgksincl.h"
#include "er_handi.h"


/* standard systems ERROR HANDLING procedure: */
er_hand(erc, rout)
Ercode erc;
Int rout;
{	er_logg(erc, rout);
}

/*ERROR LOGGING procedure: */
er_logg(erc, rout) 
Ercode	erc;
Int	rout;
{	char 	*msg, fname[30], *fnptr;
	String	see_man = "see manual";
#ifdef LONG_ERR
	char 	ext_ermsg[140];

	if (getfentry(CGKSERRORS, (Int)erc, ext_ermsg) == TRUE) {
		msg = &ext_ermsg[2]; /*to skip error-class and ':' */
	}
	else
#endif
		msg = see_man;

	err_msg("error %d ", erc);

	fnptr = fname;
	if (getfentry(CGKSFUNNAMES, rout - 100, fnptr) == TRUE)
		 err_msg("in function %s",fname);

	/* if file _msgfp is opened (i.e. if open_gks() had
	 * a 4th, non-empty string parameter), print the 
	 * message on file msgfp, else print it on screen:
 	 */
	if (_msgfp == NULL) {
		err_msg("\n");
		err_msg(msg);
		err_msg("\n");
	}
	else {
		mssge("error %d ",erc);
		if (strlen(fname) != 0) mssge("in function %s",fname);
		mssge("\n");
		mssge(msg);
		mssge("\n");
	}
}
