/* @(#) init_loc.c  version:1.8  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.init_loc.c
 * SCCS id :	init_loc.c 1.8
 * Last edited:	11/7/84 15:57:24
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 6
#define GKS6
#include "cgksincl.h"

extern	Gks	*_gkss;

Bool	wc_in_wrect();

/* INITIALIZE LOCATOR */
init_loc(ws,dn,val,pet,ea,dr)
Wss	*ws;
Devno	dn;
Locate	*val;
Pet	pet;
Drect	*ea;
Drecord	*dr;
{
	register Idevice *idev;
	int i;
	
	if ((i = ch_idev(ws, dn, pet, ea, LOCATOR, IN_LOC)) != 0)
		return(i);

	idev = &(ws->ws_devs[(Int)LOCATOR] [dn - 1]);

	if (wc_in_wrect(&val->loc_nt->nt_wind, &val->loc_pt) == FALSE) 
		Rep_Er(152, IN_LOC)

	ASS(idev->id_ival.ev_loc, *val)

	st_idev(idev, pet, ea, dr);

#ifdef	HIGH_INPUT
	(*WsScrn->s_idev)(ws, LOCATOR, dn, val, pet, ea, drec);
#endif
	return(0);
}

Bool
wc_in_wrect(wrect, wc)
Wrect	*wrect;
Wc	*wc;
{
	return  (Bool) ((wc->w_x >= wrect->w_ll.w_x ) &&
		    (wc->w_y >= wrect->w_ll.w_y ) &&
		    (wc->w_x <= wrect->w_ur.w_x ) &&
		    (wc->w_y <= wrect->w_ur.w_y )
		   ); 
}
