/* @(#) init_str.c  version:1.6  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.init_str.c
 * SCCS id :	init_str.c 1.6
 * Last edited:	10/19/84 13:57:57
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 6
#define GKS6

char *strcpy();

#include "cgksincl.h"

/* INITIALIZE STRING */
init_str(ws, dn, val, pet, ea, dr)
Wss	*ws;
Devno	dn;
String	val;
Pet	pet;
Drect	*ea;
Drecord	*dr;
{
	register Idevice *idev;
	int i;
	
	if ((i = ch_idev(ws, dn, pet, ea, STRING, IN_STR)) != 0)
		return(i);

	if (strlen(val) + 1 > dr->str_rec.str_size)
		Rep_Er(152, IN_STR);
	if (dr->str_rec.str_posn > strlen(val) + 1 ||
	    dr->str_rec.str_posn == 0)
		Rep_Er(152, IN_STR);
	if (dr->str_rec.str_posn == dr->str_rec.str_size)
		Rep_Er(152, IN_STR);

	idev = &(ws->ws_devs[(Int)STRING] [dn - 1]);

	strcpy(idev->id_ival.ev_str , val);

	st_idev(idev, pet, ea, dr);

	return(0);
}
