/* @(#) init_val.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.init_val.c
 * SCCS id :	init_val.c 1.5
 * Last edited:	10/19/84 13:57:50
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 6
#define GKS6
#include "cgksincl.h"

/* INITIALIZE VALUATOR */
init_val(ws,dn,val,pet,ea,dr)
Wss	*ws;
Devno	dn;
Value	*val;
Pet	pet;
Drect	*ea;
Drecord	*dr;
{
	register Idevice *idev;
	int i;
	
	if ((i = ch_idev(ws, dn, pet, ea, VALUATOR, IN_VAL)) != 0)
		return(i);

	if (*val < dr->val_rec.val_min || *val > dr->val_rec.val_max)
		Rep_Er(152, IN_VAL);

	idev = &(ws->ws_devs[(Int)VALUATOR] [dn - 1]);
	idev->id_ival.ev_val = *val;

	st_idev(idev, pet, ea, dr);

	return(0);
}
