/* @(#) mf_pmatt.h  version:1.4  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mf_pmatt.h
 * SCCS id :	mf_pmatt.h 1.4
 * Last edited:	11/27/84 12:20:27
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 *	set polymarker index
 */
STATIC
Bool
m_spmi(ws,i)
Wss *ws;
Bindex i;
{


	idata[0] = (Int)i;

	write_irdata(ws,M_SPMI,idata, 1, rdata, 0);

}

/*
 *	set  marker type
 */

STATIC
Bool
m_smk(ws,mt)	/*	set markertype	*/
Wss *ws;
Mtype mt;
{


	idata[0] = (Int)mt;

	write_irdata(ws,M_SMK,idata, 1, rdata, 0);


}

/*
 *	set  marker size scale factor
 */

STATIC
Bool
m_smksc(ws,ms)	
Wss *ws;
Msize ms;
{


	rdata[0] = (Real)ms;

	write_irdata(ws,M_SMKSC,idata, 0, rdata, 1);

}

/*
 *	set polymarker colour index
 */

STATIC
Bool
m_spmci(ws,i)
Wss *ws;
Cindex i;
{


	idata[0] = (Int)i;

	write_irdata(ws,M_SPMCI,idata, 1, rdata, 0);

}
