/* @(#) mf_route.h  version:1.8  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mf_route.h
 * SCCS id :	mf_route.h 1.8
 * Last edited:	11/27/84 12:22:48
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 *	auxiliary function to route item to metafile:
 */
route_item(ws,type,lrec,drec)
Wss	*ws;
Int	type;
Size	lrec;
char 	*drec;
{
	Int i;

/*
 *	fprintf(Mofp,Itmhf,type,lrec);
 */
	sprintf(Itmhdr,Itmhf,type,lrec);

#if (MF_FORMAT == MF_TEST || MF_FORMAT == MFF_F77)
/*
 *	all items are separated by newline symbol
 */
	fprintf(Mofp,"\n");
#endif
#if (MF_FORMAT == MFF_F77)
	position = 0;
#endif

	for (i=0; i<HDRLEN; i++) {
	  	putc(Itmhdr[i], Mofp);
#if (MF_FORMAT == MFF_F77)
#include "mf_newline.h"
#endif
	}

	if (lrec != 0) {
		for (i=0; i<lrec; i++) {
		  	putc(drec[i], Mofp);
#if (MF_FORMAT == MFF_F77)
#include "mf_newline.h"
#endif
		}
	}
}
/*
 *	auxiliary function to route integer and real data to metafile:
 */
write_irdata(ws,type,idata,nint,rdata,nreal)
Wss	*ws;
Itmtp	type;
Int	*idata;
Size	nint;
Real	*rdata;
Size	nreal;
{
	Int i;
	char *drecloc;

	Size lrec;	/* item data record length */
	
	lrec = IBYTE*nint + RBYTE*nreal;

	drecloc = drecconst;

	if (nint > 0){
/*
 *	integers are written to drecconst;
 */
		for (i = 0; i<nint; i++) {
		PUT_INT(drecloc,idata[i])
		}
	}

	if (nreal > 0){
/*
 *	reals are written to drecconst;
 */
		for (i = 0; i<nreal; i++) {
		PUT_REAL(drecloc,rdata[i])
		}
	}

	route_item(ws,type,lrec,drecconst);
}
