/* @(#) mf_trans.h  version:1.4  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mf_trans.h
 * SCCS id :	mf_trans.h 1.4
 * Last edited:	11/27/84 12:23:06
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 *	set clipping rectangle
 */
STATIC
Bool
m_sclpr	(ws,clr)
Wss	*ws;
Nrect	clr;
{


	rdata[0] = clr.n_ll.n_x;
	rdata[1] = clr.n_ur.n_x;
	rdata[2] = clr.n_ll.n_y;
	rdata[3] = clr.n_ur.n_y;

	write_irdata(ws,M_SCLPR,idata,0,rdata,4);

}

/*
 *	set workstation window
 */
STATIC
Bool
m_swkwn	(ws,nr)
Wss	*ws;
Nrect	nr;
{


	rdata[0] = nr.n_ll.n_x;
	rdata[1] = nr.n_ur.n_x;
	rdata[2] = nr.n_ll.n_y;
	rdata[3] = nr.n_ur.n_y;

	write_irdata(ws,M_SWKWN,idata,0,rdata,4);

}

/*
 *	set workstation viewport
 */
STATIC
Bool
m_swkvp	(ws,nr)
Wss	*ws;
Nrect	nr;
{

	rdata[0] = nr.n_ll.n_x;
	rdata[1] = nr.n_ur.n_x;
	rdata[2] = nr.n_ll.n_y;
	rdata[3] = nr.n_ur.n_y;

	write_irdata(ws,M_SWKVP,idata,0,rdata,4);

}
