/* @(#) mfhdrass.h  version:1.6  dated:84/11/27 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mfhdrass.h
 * SCCS id :	mfhdrass.h 1.6
 * Last edited:	11/27/84 12:24:39
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 *-------------------------------------------------------
 *
 *	the fields of the Metafile header are filled now;
 */

	ws->ws_wsis->wi_mfhdr->mfh_V = V;
	ws->ws_wsis->wi_mfhdr->mfh_H = H;
	ws->ws_wsis->wi_mfhdr->mfh_T = T;
	ws->ws_wsis->wi_mfhdr->mfh_L = L;
	ws->ws_wsis->wi_mfhdr->mfh_I = I;
	ws->ws_wsis->wi_mfhdr->mfh_R = R;
	ws->ws_wsis->wi_mfhdr->mfh_F = F;
	ws->ws_wsis->wi_mfhdr->mfh_RI = RI;
	ws->ws_wsis->wi_mfhdr->mfh_ZERO = ZERO;
	ws->ws_wsis->wi_mfhdr->mfh_ONE = ONE;

/*
 *	construction of item header format
 */

/*
 *	construction of (part of the) string 'GKSM'
 */
	is = 0;
	for (i = 0; i<H; i++) {
		c[is] = ws->ws_wsis->wi_mfhdr->mfh_GKSM[i];
		is ++;
	}

/*
 *	length of item header is now assigned
 */
	HDRLEN = H + T + L;


/*
 *	format for item type is constructed
 */
	c[is++] = '%';
	c[is++] = T/10 + '0';
	c[is++] = T - 10*(T/10) + '0';
	c[is++] = 'd';
/*
 *	format for item data record length is constructed
 */
	c[is++] = '%';
	c[is++] = L/10 + '0';
	c[is++] = L - 10*(L/10) + '0';
	c[is++] = 'd';
	c[is++] = '\0';

/*
 *	item header format is now assigned
 */
	for (i = 0; i<is; i++){
		ws->ws_wsis->wi_mfhdr->mfh_itmhf[i] = c[i];
	}
/*
 *	format for INTEGER in item is constructed
 */
	is = 0;
	c[is++] = '%';
	c[is++] = I/10 + '0';
	c[is++] = I - 10*(I/10) + '0';
	c[is++] = 'd';

	for (i = 0; i<is; i++){
		ws->ws_wsis->wi_mfhdr->mfh_intf[i] = c[i];
	}

/*
 *	format for REAL in item is constructed
 */
	is = 0;
	c[is++] = '%';
	c[is++] = R/10 + '0';
	c[is++] = R - 10*(R/10) + '0';
	c[is++] = 'f';

	for (i = 0; i<is; i++){
		ws->ws_wsis->wi_mfhdr->mfh_realf[i] = c[i];
	}
