/* @(#) mi_drive.c  version:1.2  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.mi_drive.c
 * SCCS id :	mi_drive.c 1.2
 * Last edited:	11/15/84 13:25:57
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#include "cgksincl.h"

/*
 * For a workstation of type MI there is no dd/di driver 
 * available.
 * Therefore the second parameter of inst_scr() is NULL.
 *
 * The function sf_mihdr() sets the function pointer 
 * pmi_hdr declared in open_ws.o to the address of the function
 * mi_hdr(), declared in mi_hdr.o.
 * open_ws() uses this pmi_hdr function pointer instead of
 * mi_hdr() directly;  if the code in open_ws.c contained
 * mi_hdr() the file mi_hdr.o would always be included,
 * whether a ws of type MI is used or not.
 * As pmi_hdr is only called in open_ws()
 * if a workstation of type MI is opened
 * one can be sure that the function mi() is executed, and
 * therefore sf_mihdr() is executed, and therefore pmi_hdr is set to
 * mi_hdr.
 */

int mi()
{
	sf_mihdr();

	return(inst_scr("mi", NULL));
	/*NULL: no driver for MI*/
}
