/* @(#) pixel.c  version:1.4  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.pixel.c
 * SCCS id :	pixel.c 1.4
 * Last edited:	10/19/84 13:56:02
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS8

#include "cgksincl.h"

/*INQUIRE PIXEL*/
Bool
pixel(ws, p, ci)
Wss	*ws;
Wc	*p;
Cindex	*ci;
{	Screen	*scr = WsScrn;
	Nc	nc;
	Dc	dc;
	int	ix, iy;
	Bool	inv;

	if (ch_state(7, IQU_PXL) != 0) return(FALSE);
	/*check on error 39*/ 
	if (scr->s_ipix == NULL) {
		rep_er(40, IQU_PXL);
		return(FALSE);
	}

	ensure(IQU_PXL);
	ws_ensure(ws, IQU_PXL);

	ntransf(p, &nc);
	ws_transf(ws, &nc, &dc);
	ix = dc.d_x;
	iy = dc.d_y;
	if (ix < 0 || iy < 0  ||
	    ix > scr->s_size.i_x || iy > scr->s_size.i_y)
		return(FALSE);
	else {
		(*scr->s_ipix)(ws, ix, iy, 1, 1, &inv, ci);
		return(TRUE);
	}
	/* ci is index in current colourtable on device.
	 * this table might differ from the colour table in the ws
	 * statelist if there has been a col_rep() call, and no 
	 * update of the display has taken place
	 */
}
