/* @(#) pl_rep.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.pl_rep.c
 * SCCS id :	pl_rep.c 1.5
 * Last edited:	10/19/84 13:55:55
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 3
#define GKS3
#include "cgksincl.h"

extern Gks	*_gkss;
extern Int	attmark[];

pl_rep(ws, pl)
Wss	*ws;
LineRep	*pl;
{
	LineRep *lr;
	Bindex	i = pl->lr_ix;
	Int	nr = ws->ws_nline;

	Ch_State(7,S_PL_R);
	Ch_Er_Ws(ws, 3 ,S_PL_R);

#ifdef METAFILE
if (ws->ws_wsd->wd_cat == MO) {
		(*MfScrn->m_splr)(ws,i,pl);
		return(0);
	}
#endif

	if (pl->lr_ci >= ws->ws_ncolr) Rep_Er(86, S_PL_R);

	lr = ws->ws_line;
	while (nr != 0 && lr->lr_ix != i) {
		nr--;
		lr++;
	}
	if (nr == 0) {
	     REALLOC(ws->ws_line,LineRep,(ws->ws_nline+1), S_PL_R)
	     lr = ws->ws_line + ws->ws_nline;
	     ws->ws_nline++;
	}
	ASS(*lr , *pl)

	if (_gkss->gk_line == i) mark_ws(ws, WS_POL);

	if ((ws->ws_wsd->wd_dmar & 01) != 0) { /*means IMM*/
		;/*immediate driver call*/
	}
	else /* means IRG*/
	if (nr != 0) {
		/*not a good check to see if there are visible effects;
		 *add test to see if index in any visible segment
		 */
		newframe(ws, S_PL_R);
	}
	return(0);
}
