/* @(#) pm_rep.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.pm_rep.c
 * SCCS id :	pm_rep.c 1.5
 * Last edited:	10/19/84 13:55:47
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 3
#define GKS3
#include "cgksincl.h"

extern Gks	*_gkss;
extern Gksi	*gksis;
extern Int	attmark[];

pm_rep(ws, mk)
Wss    *ws;
MarkRep *mk;
{
	MarkRep *mr;
	Bindex 	i = mk->mr_ix;
	Int	nr = ws->ws_nmark;

	Ch_State(7,S_PM_R);
	Ch_Er_Ws(ws,3 ,S_PM_R);
	if (mk->mr_mt < 1) Rep_Er(66, S_PM_R);

#ifdef METAFILE
if (ws->ws_wsd->wd_cat == MO) {
		(*MfScrn->m_spmr)(ws,i,mk);
		return(0);
	}
#endif

	if (mk->mr_ci >= ws->ws_ncolr) Rep_Er(86, S_PM_R);

	if (mk->mr_mt > 5){
		Int j = ws->ws_wsd->wd_nmktyp;
		Mtype *mt = ws->ws_wsd->wd_mktyp;
		while (j != 0){
			if (*mt++ == mk->mr_mt) break;
			else j--;
		}
		if (j == 0) mk->mr_mt = 3;
	}

	mr = ws->ws_mark;
	while (nr != 0 && mr->mr_ix != i) {
		nr--;
		mr++;
	}
	if (nr == 0) {
	     REALLOC(ws->ws_mark,MarkRep,ws->ws_nmark+1,S_PM_R)
	     mr = ws->ws_mark + ws->ws_nmark;
	     ws->ws_nmark++;
	}
	mk->mr_ix = i;
	ASS(*mr , *mk)

	if (_gkss->gk_mark == i) mark_ws(ws, WS_POM);

	if ((ws->ws_wsd->wd_dmar & 02) != 0) { /*means IMM*/
		;/*nothing to do; arranged by device*/
	}
	else /* means IRG*/
	if (nr != 0) {
		/*not a good check to see if there are visible effects;
		 *add test to see if index in any visible segment
		 */
		newframe(ws, S_PM_R);
	}
	return(0);
}
