/* @(#) pxl_siz.c  version:1.4  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.pxl_siz.c
 * SCCS id :	pxl_siz.c 1.4
 * Last edited:	10/19/84 13:55:01
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*this file contains an inquiry function that is not
/*implemented as a macro*/

#define GKS8

#include "cgksincl.h"

/*INQUIRE PIXEL DIMENSIONS*/
Bool
pxl_siz(ws, wr, sz)
Wss	*ws;
Wrect	*wr;
ArrSiz	*sz;
{	Nrect	nr;
	Drect	dr;
	Real 	*rp = (Real *)&dr;
	Int	i;
	Ic 	*size = &(WsScrn->s_size);

	if (ch_state(7, IQU_PA_DM) != 0) return(FALSE);
	/*ch er 39*/
	/*test on raster ws*/

	ensure(IQU_PA_DM);
	ws_ensure(ws, IQU_PA_DM);

	ntransf(&wr->w_ll, &nr.n_ll);
	ntransf(&wr->w_ur, &nr.n_ur);
	ws_transf(ws, &nr.n_ll, &dr.d_ll);
	ws_transf(ws, &nr.n_ur, &dr.d_ur);

	for (i = 0; i < 3; i++)
		if (*rp < 0.0) *rp++ = 0.0; else rp++;
	rp = (Real *)&dr;
	if(*rp > size->i_x + 1) *rp = size->i_x + 1.0; rp++;
	if(*rp > size->i_y + 1) *rp = size->i_y + 1.0; rp++;
	if(*rp > size->i_x + 1) *rp = size->i_x + 1.0; rp++;
	if(*rp > size->i_y + 1) *rp = size->i_y + 1.0;
	/*ll to ur is size->i_x + 1 pixels?*/

	sz->as_xsz = (Int)(dr.d_ur.d_x + 0.5)  -
		     (Int)(dr.d_ll.d_x + 0.5);
	sz->as_ysz = (Int)(dr.d_ur.d_y + 0.5)  -
		     (Int)(dr.d_ll.d_y + 0.5);
	return(TRUE);
}
