/* @(#) req_cho.c  version:1.11  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.req_cho.c
 * SCCS id :	req_cho.c 1.11
 * Last edited:	11/20/84 10:28:40
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*REQUEST CHOICE*/

/*pet 1:type a choice number
 *pet 3:menu selection;menu consist of a vertical menu with choices.
 *pet 7:menu selection;menu consist of a horizontal menu with choices.
 *pet 6:menu selection;menu consist of a menu with colours
 */

#define GKS 6
#define GKS6
#include "cgksincl.h"

#define	BREAK	'\0'
#define	BACKSPACE '\010'

Bool	nc_in_nrect();
Bool	ic_in_drect();
Bool	newcurs();
char *sprintf();

extern	Gks	*_gkss;
extern	Gksi	*gksis;

#include "req_choi.h"

/* REQUEST CHOICE */
Bool
req_cho(ws,dn,val)
Wss	*ws;
Devno	dn;
Choice	*val;
{
	register Idevice *idev = &(ws->ws_devs[3] [dn - 1]);
	Drect	*area = &(idev->id_area);
	Drecord *drec = &idev->id_drec;
	Cindex	inpci = drec->cho_rec.cho_col;
	Screen	*scr = WsScrn;
	Bool	no_br, inarea, deflt;
	Ic	s, ic;
	Int	i;
	Real	dy, dx;
	Choice	choice;
	Real	hor, ver;
	int	c;
	Choice	old;
	Int	chx, chy, numbers, maxnr;
	Ic	curs, curs0;
	char	val_s[50];
	String	st = " ";
	
	if (ch_state(7, RQ_CH)  != 0) return(FALSE);
	if (ch_er_ws(ws, 7, RQ_CH) != 0) return(FALSE);

	if (ch_devno(ws, CHOICE, dn, RQ_CH) != 0) return(FALSE);
	if (idev->id_mode != REQUEST) {
		rep_er(141, RQ_CH);
		return(FALSE);
	}

	ensure(RQ_CH);
	ws_ensure(ws, RQ_CH);

	if (inpci == 0) inpci = 100;/*to prevent seeing nothing*/
	no_br = TRUE;
	show_c_area(ws,idev, 0,*val);
	old = *val;
	switch (idev->id_pet) {
	case (3):
	case (6):
	case (7):
		inarea = FALSE;
		deflt = FALSE;
		ver = (area->d_ur.d_y - area->d_ll.d_y) / 
		      (Real)(drec->cho_rec.cho_nr);
		hor = (area->d_ur.d_x - area->d_ll.d_x) / 
		      (Real)(drec->cho_rec.cho_nr);
		while (inarea == FALSE && deflt == FALSE) {
			if ((c=(*WsScrn->s_inpc)(ws, &s, 0)) == BREAK){
				no_br = FALSE;
				break;
			}
			if (c == '\n') deflt = TRUE;
			else	inarea = ic_in_drect(area, &s);
		}

		if (no_br) {
			if (deflt)	choice = old;
			else {
			    if (idev->id_pet == 7) {
				dx = area->d_ll.d_x + hor;
				for (choice = 1; dx < (Real)s.i_x &&
				     choice < drec->cho_rec.cho_nr;
						choice++)
					dx += hor;
			    }
			    else {
				dy = area->d_ur.d_y - ver;
				for (choice = 1; dy > (Real)s.i_y &&
				     choice < drec->cho_rec.cho_nr;
						choice++)
					dy -= ver;
			    }
			    show_c_area(ws, idev, old, choice);
			}
		}
		break;
	case (1):
	default :
		choice = numbers = 0;
		maxnr = 9;
		chx = scr->s_chsz.i_x;
		chy = scr->s_chsz.i_y;
		curs0.i_x = area->d_ll.d_x + 1;
		curs0.i_y = area->d_ur.d_y - 1 - chy;
		ASS(curs , curs0);

		while( (c=(*WsScrn->s_inpk)(ws, &ic,&curs)) != EOF
	     	    && (c != BREAK) && (c != '\n') )  
		if (c>= '0' && c <= '9' && numbers < maxnr) {
	 		choice = 10*choice + ( c - '0');
			if (numbers++ == 0) { 
			    if (scr->s_colr)
				(*scr->s_colr)(ws, 0);
			    sprintf((char *)val_s, "%d", *val);
			    i = 0;
			    while (val_s[i] != '\0') {
				st[0] = val_s[i++];
				(*scr->s_char)(ws, st, &curs);
				newcurs(1,&curs,&curs, area, chx, chy);
			    }
			    if (scr->s_colr)
				(*scr->s_colr)(ws, inpci);
			    ASS(curs , curs0)
			}
			st[0] = c;
			(*scr->s_char)(ws, st, &curs);
			newcurs(1,&curs, &curs, area, chx, chy);
		}

		if (c == BREAK) no_br = FALSE;
		else if (c =='\n' && numbers ==0) choice = *val;
		break;
	}

	if (no_br == TRUE) *val = choice;
	else 		   *val = 0;

	if (no_br == FALSE || idev->id_echo == FALSE)
		fade_c_area(ws, idev, *val); 

	return(no_br);
}
