/* @(#) req_choi.h  version:1.7.1.3  dated:84/12/10 */
/*
 * SCCS file:	SCCS/s.req_choi.h
 * SCCS id :	req_choi.h 1.7.1.3
 * Last edited:	12/10/84 21:18:33
 */

show_c_area(ws, idev, old, val)
Wss	*ws;
Idevice	*idev;
Choice	old, val;
{
	register Screen	*scr = WsScrn;
	register char 	ctmp, *cptr;
	char	*cho_str;
	Ic	curs, ic[4], ict;
	Cindex	oldci = scr->s_ccol, col_nr;
	Drect	*area = &idev->id_area;
	Drecord *drec = &idev->id_drec;
	Cindex	inpci = drec->cho_rec.cho_col;
	Int 	nr, digits;
	register Int i;
	char	val_s[10];
	Real	ytxt, xystart, hor, ver, max_rght;

	if (inpci == 0) inpci = 2;
	if (scr->s_colr) (*scr->s_colr)(ws,  inpci);

	switch (idev->id_pet) {
	case (3): /*standing menu with strings*/
	case (6): /*standing menu with coloured rects */
	case (7): /*laying menu with strings*/
		nr = drec->cho_rec.cho_nr;
		setic(area, ic);

		/*calculate height or width of each item box*/
		/* and starting values */
		if (idev->id_pet == 7) {
		    hor = (area->d_ur.d_x - area->d_ll.d_x) /(Real)nr;
		    ict.i_y = (area->d_ur.d_y + area->d_ll.d_y) / 2.0 -
				0.5 * scr->s_chsz.i_y;
		    xystart = ic[2].i_x = ic[3].i_x = area->d_ll.d_x;
		    max_rght = ic[2].i_x - scr->s_chsz.i_x;
		}
		else {
		    ver = (area->d_ur.d_y - area->d_ll.d_y) /(Real)nr;
		    /*strings are supposed not to succeed max_rght*/
		    max_rght = area->d_ur.d_x - scr->s_chsz.i_x;
		    xystart = ic[0].i_y = ic[3].i_y = area->d_ur.d_y;
		    ytxt = ic[0].i_y + 0.5 * ver -
					0.4 * scr->s_chsz.i_y;
		}

		for (i=0; i<nr; i++) { 
		  if (idev->id_pet == 7) { /*laying menu*/
			ic[0].i_x = ic[1].i_x = xystart;
			if (i != nr - 1) {
				xystart += hor;
				ic[2].i_x = ic[3].i_x = xystart;
			}
			else {
				ic[2].i_x = ic[3].i_x = area->d_ur.d_x;
			}
			max_rght += hor;
		  }
		  else { /*standing menu*/
			ic[1].i_y = ic[2].i_y = xystart;
			if (i != nr - 1) {
				xystart -= ver;
				ic[0].i_y = ic[3].i_y = xystart;
			}
			else	ic[0].i_y = ic[3].i_y = area->d_ll.d_y;

			ytxt -= ver;
			ict.i_y = ytxt;
		  }

		  /* before a choice is made(old==0) show all choices*/
		  /* else change the position of the echo mark */
		  if (old == 0) {
		     if (idev->id_pet == 3 || idev->id_pet == 7) {
			fd_rct_dr_bnd(ws, ic, inpci);
			/* fd_rct_dr_bnd erases old contents of rect*/
			ict.i_x = ic[0].i_x + 4;
			cho_str = drec->cho_rec.cho_str[i];
			cptr = cho_str;
			while ((*cptr != '\0') &&
			       (ict.i_x <= max_rght)){
				ict.i_x += scr->s_chsz.i_x;
				cptr++;
			}
			if ((ctmp = *cptr) != '\0'){
				*cptr = '\0';
			}
			ict.i_x = ic[0].i_x + 4;
			(*scr->s_char)(ws, cho_str, &ict);
			*cptr = ctmp;
		     }
		     else if (idev->id_pet == 6){
			col_nr = drec->cho_rec.cho_nrs[i];
			if (col_nr != 0) {
				if (scr->s_colr)
					(*scr->s_colr)(ws, col_nr);
				(*scr->s_rect)(ws, &ic[0], &ic[2]);
			}
			else {
				fd_rct_dr_bnd(ws, ic, inpci);
			}
		     }
		  }

		  if ((i + 1 == (Int)val) || (i + 1 == old)) {
			if (scr->s_colr) {
				if (i+1 == val)  {
					(*scr->s_colr)(ws,  inpci);
				}
				else 	(*scr->s_colr)(ws,  0);
			}

			cho_str = drec->cho_rec.cho_str[i];

			/* draw or fade a marker (if there is room)*/
			if(idev->id_pet == 3 || idev->id_pet ==7) {
			   ict.i_x = ic[0].i_x + 4;
			   ict.i_x += strlen(cho_str) * scr->s_chsz.i_x;

			   if (ict.i_x <= max_rght -2 -scr->s_chsz.i_x){
				ict.i_x += (scr->s_chsz.i_x / 3);
				cptr ="<";
				(*scr->s_char)(ws, cptr, &ict);
			   }
		        }
			else if (idev->id_pet == 6) {
				ict.i_x = ic[0].i_x + 1;
				cptr = "*";
				(*scr->s_char)(ws, cptr, &ict);
			}
		  }
		}
		break;
	case (1):
	default :
		sprintf(val_s, "%d", val);
		setic(area, ic);
		curs.i_x = area->d_ll.d_x + 1;
		curs.i_y = area->d_ur.d_y - 1 - scr->s_chsz.i_y;
		fd_rct_dr_bnd(ws, ic, inpci);
		(*scr->s_char)(ws, val_s, &curs);
		break;
	}

	if (scr->s_colr) (*scr->s_colr)(ws,  oldci);
}

fade_c_area(ws, idev, val)
Wss	*ws;
Idevice	*idev;
Choice	val;
{
	Drect	*area = &(idev->id_area);

	switch (idev->id_pet) {
	case (1):
	default :
		faderect(ws, &area->d_ll, &area->d_ur);
		break;
	}
}
