/* @(#) req_str.c  version:1.11  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.req_str.c
 * SCCS id :	req_str.c 1.11
 * Last edited:	11/20/84 10:28:26
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 6
#define GKS6
#include "cgksincl.h"

#define	BREAK	'\0'
#define	BACKSPACE '\010'

Bool	nc_in_nrect();
Bool	ic_in_drect();
extern	Gks	*_gkss;
extern	Gksi	*gksis;

#include "req_stri.h"

/* REQUEST STRING */
Bool
req_str(ws,dn,val)
Wss	*ws;
Devno	dn;
String	val;
{
	register Idevice *idev = &(ws->ws_devs[5] [dn - 1]);
	Drect	*area = &idev->id_area;
	Cindex	inpci = idev->id_drec.str_rec.str_col;
	String	istr = &(idev->id_ival.ev_str[0]);
	Int	istrlen  = strlen(istr);
	Screen	*scr = WsScrn;
	Cindex	ccol = scr->s_ccol;
	Int	st_ix, i, j, bufsz, charx, chary, startix;
	Ic	ic0, ic, curs, curs2, curs_st;
	int	c;
	Bool	is_fade= TRUE;
	String  st ;
	char	*cptr;

	if (ch_state(7, RQ_STR) != 0) return(FALSE);
	if (ch_er_ws(ws, 7, RQ_STR)  != 0) return(FALSE);

	if (ch_devno(ws, STRING, dn, RQ_STR) != 0) return(FALSE);
	if (idev->id_mode != REQUEST) {
		rep_er(141, RQ_STR);
		return(FALSE);
	}
	
	ensure(RQ_STR);
	ws_ensure(ws, RQ_STR);

	MALLOC(st, char , (istrlen+1), RQ_STR)

	bufsz = idev->id_drec.str_rec.str_size;
	/*bufsz is the max size of "the string, including \0" */
	charx = scr->s_chsz.i_x;
	chary = scr->s_chsz.i_y;
	if (idev->id_drec.str_rec.str_col != 0) show_s_area(ws, idev);

	ic0.i_x = area->d_ll.d_x     + charx;
	ic0.i_y = area->d_ur.d_y - 1 - chary;
	ASS(curs , ic0)
	for (i = 0; i < istrlen; i++) {
		val[i] = istr[i];
		/* in previous version string was 
		 * drawn here for the 2nd time.
		 * why?
		 */
	}
	val[istrlen] = '\0';

	startix = idev->id_drec.str_rec.str_posn - 1;
	ASS(curs , ic0)
	for ( i = 0; i < startix; i++) 
		newcurs(1, &curs, &curs, area, charx, chary);

	i = startix;/*?*/
	while ((c=(*scr->s_inpk)(ws, &ic,&curs)) != EOF &&
		c != BREAK && c != '\n' ) {
		switch(idev->id_pet) {
		case (1):
		case (2):
		default :
		    if (is_fade == TRUE) {/* fade initial string :*/
			is_fade = FALSE;
			if (scr->s_colr)
				(*scr->s_colr)(ws, 0);
			ASS(curs2, curs)
			cptr = st;
			ASS(curs_st, curs)
			for (j = i; j < istrlen; j++) {
				*cptr++ = istr[j];
			        if (newcurs(1, &curs2, &curs2, area, 
					    charx,chary) == FALSE) {
					*cptr = '\0';
					(*scr->s_char)(ws, st,&curs_st);
					cptr = st;
					ASS(curs_st, curs2)
				}
			}
			*cptr = '\0';
			if (st[0] != '\0') 
				(*scr->s_char)(ws, st,&curs_st);
			st[1] = '\0';/* to draw strings of 1 char*/
		    }	

		    if (c != BACKSPACE) {
		      if (i < bufsz - 1) {
			if (scr->s_colr)
				(*scr->s_colr)(ws, inpci);
			st[0] = c;
		    	(*scr->s_char)(ws, st, &curs);
			newcurs(1,&curs,&curs,area,charx,chary);
		    	val[i++] = c;
			val[i  ] = '\0';
		      }
		    }
		    else if (i != 0) {
			newcurs(0, &curs, &curs, area, charx, chary);
			if (scr->s_colr) (*scr->s_colr)(ws, 0);
			i--;
			st[0] = val[i];
			(*scr->s_char)(ws, st, &curs);
			val[i] = '\0';
			if (scr->s_colr) (*scr->s_colr)(ws,inpci);

		    }
		    break;
		}
	}
	if (scr->s_colr) (*scr->s_colr)(ws, ccol);

	if (idev->id_echo == FALSE || c == BREAK)
		fade_s_area(ws, idev);

	if (c == BREAK) val[0] = '\0';

	FREE(st)

	return((Bool)(c != BREAK));
}

/* see remark at top page 52;*/
/*so that still to do in request functions*/
