/* @(#) req_stri.h  version:1.8  dated:84/11/20 */
/*
 * SCCS file:	SCCS/s.req_stri.h
 * SCCS id :	req_stri.h 1.8
 * Last edited:	11/20/84 10:28:22
 */

Bool
newcurs(ii, cursold, cursnew, area, charx, chary)
Ic	*cursold, *cursnew;
Drect	*area; /* area in which *cursnew must be */
Int	ii; /*1 if cursor goes to the right, 0 if to the left */
Int	charx, chary;
{
	Ic ic;
	Bool normal_right = TRUE; 

	ASS(ic, *cursold)

	if (ii == 1) {
		ic.i_x += charx;
		if ( ic.i_x + charx >= (Int)area->d_ur.d_x) {
			normal_right = FALSE;
			ic.i_x = (Int)area->d_ll.d_x + charx;
			if(ic.i_y - (Int)area->d_ll.d_y >= chary )
				ic.i_y -= chary + 1;
			else
			    ic.i_y = area->d_ur.d_y - chary - 1;
		}
	}
	else	{
		normal_right = FALSE;
		ic.i_x -= charx;
		if (ic.i_x < (Int)area->d_ll.d_x + charx) {
			do ic.i_x += charx;
			while (ic.i_x + charx <
				(Int)area->d_ur.d_x - charx);
			if ((Int)area->d_ur.d_y - ic.i_y> chary + 1)
			  	ic.i_y += chary + 1;
			else
				while (ic.i_y - (Int)area->d_ll.d_y > chary)
				  ic.i_y -= chary + 1;
		}
	}
	ASS(*cursnew , ic)

	return(normal_right);
}

show_s_area(ws, idev)
Wss	*ws;
Idevice	*idev;
{
	Screen	*scr = WsScrn;
	String	istr = &(idev->id_ival.ev_str[0]);
	Int	charx, chary, st_ix;
	char	*c;	
	Ic	curs, curs_st, ic0, ic[4];
	Drect	*area = &(idev->id_area);
	Cindex	inpci = idev->id_drec.str_rec.str_col;
	String	st;

	MALLOC(st, char, (strlen(istr) + 1), RQ_STR);
	charx = scr->s_chsz.i_x;
	chary = scr->s_chsz.i_y;
	ic0.i_x = idev->id_area.d_ll.d_x + charx;
	ic0.i_y = idev->id_area.d_ur.d_y - 1 - scr->s_chsz.i_y;
	ASS(curs , ic0)

	c =istr;

	switch(idev->id_pet) {
	case (1):
	case (2): /*same as 1; however without showing rectangle*/
	default :
		if (idev->id_pet == 2) {
			faderect(ws, &area->d_ll, &area->d_ur);
		}
		else {
			setic(area, ic);
			fd_rct_dr_bnd(ws, ic, inpci);/*does a faderect*/
		}

		if (scr->s_colr) 
			(*scr->s_colr)(ws, inpci);

		ASS(curs_st , curs)
		st_ix = 0;
		while (*c) {
			st[st_ix++] = *c;
		        if (newcurs(1,&curs,&curs,area, charx, chary)
				== FALSE){
				st[st_ix] = '\0';
				(*scr->s_char)(ws, st, &curs_st);
				ASS(curs_st, curs)
				st_ix = 0;
			}
		   	c++;
		}
		if (st_ix != 0) {
			st[st_ix] = '\0';
			(*scr->s_char)(ws, st, &curs_st);
		}

		break;
	}
	FREE(st)
}

fade_s_area(ws, idev)
Wss	*ws;
Idevice	*idev;
{	Drect	*area = &idev->id_area;

	switch(idev->id_pet) {
	case (1):
	case (2):
	default:
		faderect(ws, &area->d_ll, &area->d_ur);
		break;
	}
}
