/* @(#) s_clip.c  version:1.7  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.s_clip.c
 * SCCS id :	s_clip.c 1.7
 * Last edited:	10/19/84 13:52:33
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 4
#define GKS4

#include "cgksincl.h"

extern	Nrect ndc;
extern	Gks	*_gkss;
extern	Gksd	*gksd;
extern	Gksi	*gksis;

s_clip(flg)
Bool flg;
{
#ifdef METAFILE
	Bool flgold = flg;
	Nrect unit, nrtmp;
#endif
	Ch_State(8, S_CLP);
	_gkss->gk_clip = flg;

	ch_mark(SG_CLP);
	msk_openws(WS_CLP);
#ifdef METAFILE
	if (flg != flgold) {
		if (flg == TRUE) {
			/* clip rectangle is sent to all active ws
	 		 * of category MO, if clipping is switched 
			 * from off to on
			 */
			MF_ATTENSURE(m_sclpr,gk_curnt->nt_view)
		}
		else {
			/* unit clip rectangle is sent to all active
			 * workstations	of category MO, if clipping
			 * is switched from on to off
			 */
			unit.n_ll.n_x = unit.n_ll.n_y = 0.0;
			unit.n_ur.n_x = unit.n_ur.n_y = 1.0;
			ASS(nrtmp,_gkss->gk_curnt->nt_view)
			ASS(_gkss->gk_curnt->nt_view,unit)
			MF_ATTENSURE(m_sclpr,gk_curnt->nt_view)
			ASS(_gkss->gk_curnt->nt_view,nrtmp)
			
		}
	}
#endif
	return(0);
}
