/* @(#) s_segpri.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.s_segpri.c
 * SCCS id :	s_segpri.c 1.5
 * Last edited:	10/19/84 13:50:13
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 5
#define GKS5
#include	"cgksincl.h"

extern	Gks	*_gkss;
extern	Gksd	*gksd;

#include 	"s_segprii.h"

/*5 SET SEGMENT PRIORITY */
s_segpri(seg,pri)
Seg	*seg;
Segpri	pri;
{
	Wss	*ws;	
	Bool	high;
	Int	i;
	Seginst	*segi;

	Ch_State(7, S_SG_PR);
	if (ch_122(seg, S_SG_PR) != 0) return(122);
	if (pri > 1.0) Rep_Er(126, S_SG_PR);

	segi = _gkss->gk_segs;
	while (segi->si_this != seg) segi = segi->si_next;

	high = (Bool)(pri > seg->sg_pri);
	seg->sg_pri = pri;

	rearr_sg(segi, &(_gkss->gk_segs), high);

	for(i = 0; i < gksd->gd_nwsas; i++) {
		if ((ws = seg->sg_onws[i]) != NULL) {
			segi = ws->ws_segs;
			while ((segi != 0) && (segi->si_this != seg))
				segi = segi->si_next;
			/*if (segi == 0) Rep_Er(122, S_SG_PR);*/
			rearr_sg(segi, &(ws->ws_segs),high);
		}
	}

#ifdef METAFILE
	/*
	 * attribute is written to all ws of cat. MO
	 * associated with segment;
	 */
	MF_SGATTENS(m_ssgp,seg,sg_pri)
#endif
	return(0);
}
