/* @(#) tekgks.h  version:1.8.2.2  dated:85/01/11 */
/*
 * SCCS file:	SCCS/s.tekgks.h
 * SCCS id :	tekgks.h 1.8.2.2
 * Last edited:	1/11/85 13:21:13
 */

/*This file contains GKS functions for the AED */

/**********************POLYMARK*********************/
static
dr_dot(ws, s, msize , eras)
Wss	*ws;
Msize	msize;
Ic	*s;
Bool	eras;	
{
#if	(TRMTYP == 4014)
	drawhard(ws,  ".", s);
#endif
}


static
dr_circle(ws, s, msize , eras)
Wss	*ws;
Msize	msize;
Ic	*s;
Bool	eras;
{	Int radius = (Int)(msize * CHARX * 0.4);
}

static
mk_line(ws, scr, fromx, fromy, tox, toy)
Wss	*ws;
Screen	*scr;
Int	fromx, fromy, tox, toy;
{	Ic ic[2];
	ic[0].i_x = fromx; ic[0].i_y = fromy;
	ic[1].i_x = tox;   ic[1].i_y = toy;
	(*scr->s_line)(ws, 2, ic, SOLIDL, 1.0);
}

static
dr_plus(ws, s, msize , eras)
Wss	*ws;
Msize	msize;
Ic	*s;
Bool	eras;
{	register Int sz = (Int) (0.4 * msize * CHARX);
	Screen *scr = WsScrn;

	mk_line(ws, scr, s->i_x - sz, s->i_y, s->i_x + sz, s->i_y);
	mk_line(ws, scr, s->i_x, s->i_y - sz, s->i_x, s->i_y + sz);
}

static
dr_asterisk(ws, s, msize ,eras)
Wss	*ws;
Ic	*s;
Msize	msize;
Bool	eras;
{	register Int sz = (Int)(0.4 * msize * CHARX);
	Screen *scr = WsScrn;
	register Int	up;

	up = (Int)(sz / sqrt(2.0));
	mk_line(ws, scr, s->i_x - sz, s->i_y, s->i_x + sz, s->i_y);
	mk_line(ws, scr, s->i_x, s->i_y - sz, s->i_x, s->i_y + sz);
	mk_line(ws, scr, s->i_x-up, s->i_y-up, s->i_x+up, s->i_y+up);
	mk_line(ws, scr, s->i_x+up, s->i_y-up, s->i_x-up, s->i_y+up);
}

static
dr_cross (ws, s, msize , eras)
Wss	*ws;
Msize	msize;
Ic	*s;
Bool	eras;
{	register Int sz = (Int)(0.8 * msize * CHARX) / 2;
	Screen *scr = WsScrn;

	mk_line(ws, scr, s->i_x+sz, s->i_y+sz, s->i_x-sz, s->i_y-sz);
	mk_line(ws, scr, s->i_x+sz, s->i_y-sz, s->i_x-sz, s->i_y+sz);
}

static
Fun pmarkt[] = {dr_dot, dr_plus, dr_asterisk, dr_circle, dr_cross};

static
Bool drawmark(ws, n, s, ms, mt, eras)
Wss	*ws;
Size	n;
Ic	*s;
Msize	ms;
Bool	eras;	
Mtype	mt;
{
	while (n--)
		(*pmarkt[mt-1])(ws, s++, ms, eras);
}
