/* @(#) tx_rep.c  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.tx_rep.c
 * SCCS id :	tx_rep.c 1.5
 * Last edited:	10/19/84 13:45:54
 *
 * Author:	Behr de Ruiter, Miente Bakker, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 3
#define GKS3
#include "cgksincl.h"

extern Gks	*_gkss;
extern Gksi	*gksis;
extern Int	attmark[];

tx_rep(ws, tx)
Wss    *ws;
TextRep *tx;
{
	TextRep *tr;
	Int	nr = ws->ws_ntext;
	FoPr   *fp;
	Int    nrfpr;
	Bindex  bi = tx->tx_ix;

	Ch_State(7, S_TX_R);
	Ch_Er_Ws(ws, 3, S_TX_R);
	if  (tx->tx_fp.fp_fo == 0) Rep_Er(70, S_TX_R);

#ifdef METAFILE
if (ws->ws_wsd->wd_cat == MO) {
		(*MfScrn->m_stxr)(ws,bi,tx);
		return(0);
	}
#endif

	nrfpr = ws->ws_wsd->wd_nfopr;
	fp    = ws->ws_wsd->wd_fopr;

	while (nrfpr != 0) {
		if ((fp->fp_fo == tx->tx_fp.fp_fo) &&
		    (fp->fp_pr == tx->tx_fp.fp_pr))
			break;
		else {	fp++;
			nrfpr--;
		}
	}
	if (nrfpr == 0) Rep_Er(71, S_TX_R);
	if (tx->tx_chef == 0.0) Rep_Er(72, S_TX_R);
	if (tx->tx_ci >= ws->ws_ncolr) Rep_Er(86, S_TX_R);

	tr = ws->ws_text;
	while (nr != 0 && tr->tx_ix != bi) {
		nr--;
		tr++;
	}
	if (nr == 0) {
	     REALLOC(ws->ws_text,TextRep,ws->ws_ntext+1,S_TX_R)
	     tr = ws->ws_text + ws->ws_ntext;
	     ws->ws_ntext++;
	}
	ASS(*tr , *tx)

	if (_gkss->gk_text == bi) mark_ws(ws, WS_TXT);

	if ((ws->ws_wsd->wd_dmar & 04) != 0) { /*means IMM*/
		;/*nothing to do; arranged by device*/
	}
	else /* means IRG*/
	if (nr != 0) {
		/*not a good check to see if there are visible effects;
		 *add test to see if index in any visible segment
		 */
		newframe(ws, S_TX_R);
	}
	return(0);
}
