/* @(#) u_mifns.c  version:1.3  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.u_mifns.c
 * SCCS id :	u_mifns.c 1.3
 * Last edited:	10/17/84 10:46:27
 *
 * Author:	Miente Bakker , Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS2
#define GKS7
#define GKS 7

#include	"mi_itp.h"

/*
 *	auxiliary to transform a charater string of
 *	R bytes into a real;
 */
Real dcd_real(datrec)
char	*datrec;
{	/* provisional implementation */

	Real r;

	static char rstr[15];
	Int i, sc;

	for (i = 0; i<RBYT; i++) {
		rstr[i] = datrec[i];}

	rstr[RBYT] = '\0';
	sc = sscanf(rstr,"%f",&r);
	if (sc != 1)
	mssge("\ndcd_real:%10s   %15f   %2d\n",rstr,r,sc);
	return(r);
}

/*
 *	auxiliary to transform a charater string of
 *	I bytes into a integer;
 */
Int dcd_int(datrec)
char	*datrec;
{	/* provisional implementation */

	Int r;
	static char istr[15];
	Int i, sc;

	for (i = 0; i<IBYT; i++) {
		istr[i] = datrec[i];}

	istr[IBYT] = '\0';
	sc = sscanf(istr,"%d",&r);
	if (sc != 1)
	mssge("\ndcd_int:%6s%6d%2d\n",istr,r,sc);
	return(r);

}

/*
 *	auxiliary function to obtain the pointer of a segment,
 *	given its name
 */
Seg *segbyname(name,ITYPE)
Int name, ITYPE;
{
	Seg *s;
	Seginst *si;

	si = _gkss->gk_segs;

	while (si != NULL && si->si_this->sg_sn != name){
			si = si->si_next;}

	if (si == NULL) {
		mssge("\n segbyname failed when called ");
		mssge("from itp_ no %d\n",ITYPE);
		s = NULL;
	} else {
		s = si->si_this ;
	}

	return(s);
}
