/* @(#) val_mode.c  version:1.6  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.val_mode.c
 * SCCS id :	val_mode.c 1.6
 * Last edited:	10/19/84 13:40:50
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS 6
#define GKS6
#include "cgksincl.h"


/* SET VALUATOR MODE */
val_mode(ws,dn,mo,echo)
Wss	*ws;
Devno	dn;
Imode	mo;
Bool	echo;
{	register Idevice *idev;
	Bool	hor;
	Drect	*area;

	Ch_State(7, S_VAL_M);
	Ch_Er_Ws(ws, 7, S_VAL_M);
	
	idev = &(ws->ws_devs[(Int)VALUATOR] [dn - 1]);
	idev->id_mode = mo; 
	idev->id_echo = echo;
	
	area = &(idev->id_area);
	hor =(Bool)((area->d_ur.d_x - area->d_ll.d_x) >=
		(area->d_ur.d_y - area->d_ll.d_y)); 
	if ((echo == TRUE) && (mo != REQUEST)) {
		show_v_area(ws,idev,hor);
	}
	else if ((echo == FALSE) || (mo == REQUEST)) {
		fade_v_area(ws, idev, hor);
	}
	return(0);
}
