/* @(#) verplot.h  version:1.2  dated:84/11/20 */
/*
 * SCCS file:	SCCS/s.verplot.h
 * SCCS id :	verplot.h 1.2
 * Last edited:	10/19/84 13:39:39
 */

extern File	*verout;

arc(xi,yi,x0,y0,x1,y1)
{
	putc('a',verout);
	putsi(xi);
	putsi(yi);
	putsi(x0);
	putsi(y0);
	putsi(x1);
	putsi(y1);
}
box(x0, y0, x1, y1)
{
	move(x0, y0);
	cont(x0, y1);
	cont(x1, y1);
	cont(x1, y0);
	cont(x0, y0);
	move(x1, y1);
}
circle(x,y,r){
	putc('c',verout);
	putsi(x);
	putsi(y);
	putsi(r);
}
closevt(){
	fflush(verout);
}
closepl(){
	fflush(verout);
}

cont(xi,yi){
	putc('n',verout);
	putsi(xi);
	putsi(yi);
}

dot(xi,yi,dx,n,pat)
int  pat[];
{
	int i;
	putc('d',verout);
	putsi(xi);
	putsi(yi);
	putsi(dx);
	putsi(n);
	for(i=0; i<n; i++)putsi(pat[i]);
}

erase(){
	putc('e',verout);
}

label(s)
char *s;
{
	int i;
	putc('t',verout);
	for(i=0;s[i];)putc(s[i++],verout);
	putc('\n',verout);
}
line(x0,y0,x1,y1){
	putc('l',verout);
	putsi(x0);
	putsi(y0);
	putsi(x1);
	putsi(y1);
}

linemod(s)
char *s;
{
	int i;
	putc('f',verout);
	for(i=0;s[i];)putc(s[i++],verout);
	putc('\n',verout);
}
move(xi,yi){
	putc('m',verout);
	putsi(xi);
	putsi(yi);
}

openvt(){
}
openpl(){
}

point(xi,yi){
	putc('p',verout);
	putsi(xi);
	putsi(yi);
}
putsi(a){
	putc((char)a,verout);
	putc((char)(a>>8),verout);
}
space(x0,y0,x1,y1){
	putc('s',verout);
	putsi(x0);
	putsi(y0);
	putsi(x1);
	putsi(y1);
}
