/* @(#) w_polymark.c  version:1.2  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	/userfs1/aio/behr/gks/lib/SCCS/s.w_polymark.c
 * SCCS id :	w_polymark.c 1.2
 * Last edited:	11/12/84 13:15:59
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS2
#define GKS 2

#include "cgksincl.h"

extern	Gks	*_gkss;
extern	GksState gkstate;
extern	Gksi	*gksis;
extern	Gksd	*gksd;
extern 	Fun	pws_pmark;

Bool	ic_in_drect();
Bool	dc_in_drect();
Nc	*outprim();

ws_pmark(ws, n, pr)
Nc	*pr;
Wss	*ws;
Size	n;
{
	Screen	*scr = WsScrn;
#ifdef METAFILE
	Mf_screen *mfscr = MfScrn;
#endif
	MarkRep	*mrep = &ws->ws_wsis->wi_mrep;
	Nc	*nptr, nc;
	Ic	*ic, *ic2;
	Dc	dc;
	Bool	eras = FALSE;
	Drect	*clip_w = &(ws->ws_wsis->wi_clipr);
	Size	nnew = 0;

	if (ws->ws_wsd->wd_cat != MO) {
/* calls a driver for ws of cat. != MO	*/
		if (scr->s_matt) (*scr->s_matt)(ws, *mrep);
		if (mrep->mr_ci == 0 && scr->s_colr == 0) eras = TRUE;

		CALLOC(ic, Ic, n, POM)
		ic2 = ic;
		nptr = pr;
		while (n--) {
			ASS(nc , *nptr)
			nptr++;
			ws_transf(ws, &nc, &dc);
			if (dc_in_drect(clip_w, &dc) == TRUE) {
				dc_to_ic(ic2, &dc);
				nnew++;
				ic2++;
			}
		}
		(*scr->s_mark)
		      (ws, nnew, ic, mrep->mr_ms,mrep->mr_mt,eras);
		FREE(ic)
	}
	else { ;
/*
 * calls a driver for ws of cat MO
 */

#ifdef METAFILE
#ifdef LAZY
/* in case of lazy evaluation the polymarker attributes
 * marker type, marker size scale factor and polymarker 
 * colour index are routed to the ws		
 */
		(*mfscr->m_smk)(ws,mrep->mr_mt);
		(*mfscr->m_smksc)(ws,mrep->mr_ms);
		(*mfscr->m_spmci)(ws,mrep->mr_ci);
#endif
		(*mfscr->m_pm)(ws,n,pr);
#endif
	}
}


sf_pmark()
{
	pws_pmark = ws_pmark;
}
