/* @(#) w_text.c  version:1.2  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	/userfs1/aio/behr/gks/lib/SCCS/s.w_text.c
 * SCCS id :	w_text.c 1.2
 * Last edited:	11/12/84 13:16:03
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

#define GKS2
#define GKS 2

#include "cgksincl.h"


char	*seg_block();
Bool	ch_in_cliprect();
long lseek();
char *strcpy();
char *sprintf();

extern	Gks	*_gkss;
extern	GksState gkstate;
extern	Gksd	*gksd;
extern	Gksi	*gksis;
extern 	Fun pws_text;

#ifdef BERKFONT
	/* definition of BERKFONT: see cgkslocal.h */

String GKSfonts[]= {
/*1*/	"hard char",
/*2*/	"clarendon.18",
/*3*/	"bodoni.i.10",
/*4*/	"times.b.10",
/*5*/	"meteor.r.12",
/*6*/	"meteor.i.10",
/*7*/	"stare.i.16",
/*8*/	"stare.b.16",
/*9*/	"playbill.10",
/*10*/	"delegate.b.12",
/*11*/	"fix.14"
	};
#endif
Int	fontindex;

ws_text(ws, st, pr)
Wss	*ws;
String	st;
Nc	*pr;
{
	char	c, *s;
	String	stin;
	Ic	ic, ur, icin;
	Nc	nc;
	Dc	dc;
	Drect	*dclip = &ws->ws_wsis->wi_clipr;
	TextRep *trep = &ws->ws_wsis->wi_trep;
	Screen	*scr = WsScrn;
	String	fontstr;
	Bool	eras = FALSE;
	Int	i;

	if (ws->ws_wsd->wd_cat == MO){;
#ifdef METAFILE
/*
 *	text is sent to metafile output
 */
		(*MfScrn->m_tx)(ws,pr,st);
#endif
	} 
	else {
		ASS(nc , *pr)
		s = st;
		ws_transf(ws, &nc, &dc);

		dc_to_ic(&ic, &dc);
		ur.i_y = dc.d_y ;

		if (scr->s_tatt) (*scr->s_tatt)(ws, *trep);
		/* add other attributes */

		switch (trep->tx_fp.fp_fo) {
		case (1):
#ifndef BERKFONT
		default:
#endif
		    MALLOC(stin, char, (strlen(st) + 1), TXT)
		    switch (trep->tx_fp.fp_pr) {
		    case (CHAR):
			if (trep->tx_ci == 0 &&
			    (scr->s_colr == 0 && scr->s_eral != 0 ) )
				eras = TRUE;
			if (eras) (*scr->s_eral)(ws, TRUE);
			stin[1] = '\0';
			while (stin[0] = *s++) {
				if ( ch_in_cliprect(ws, &ic, dclip))
					(*scr->s_char)(ws, stin, &ic);
				ic.i_x += scr->s_chsz.i_x;
			}
			if (eras) (*scr->s_eral)(ws, FALSE);

			break;
		    case (STR):
			if (trep->tx_ci == 0 &&
			    (scr->s_colr == 0 && scr->s_eral != 0 ) )
				eras = TRUE;
			if (eras) (*scr->s_eral)(ws, TRUE);
			while ((c = *s) != '\0' &&
			       ch_in_cliprect(ws, &ic, dclip) == FALSE) {
				s++;
				ic.i_x += scr->s_chsz.i_x;
			}
			i = 0;
			if (c != '\0') {
				ASS(icin, ic)
				while (c = *s++) {
					if (ch_in_cliprect(ws, &ic, dclip))
						stin[i++] = c;
					ic.i_x += scr->s_chsz.i_x;
				}
			}
			if (i > 0) {
				stin[i] = '\0';
				(*scr->s_char)(ws, &(stin[0]), &icin);
			}
			if (eras) (*scr->s_eral)(ws, FALSE);
			break;
		    case (STROKEP):
			break;
		    }
		    FREE(stin)
		    break;
#ifdef BERKFONT
		case (2):
		case (3):
		case (4):
		case (5):
		case (6):
		case (7):
		case (8):
		case (9):
		case (10):
		case (11):
		default:
		    fontindex = (trep->tx_fp.fp_fo <= 11) ?
			(Int)trep->tx_fp.fp_fo - 1 : 10;
		    fontstr =  GKSfonts[fontindex];
		    WsBerkFont(ws, st, pr, fontstr);
		    break;
#endif
		}
	}
}

sf_text()
{	
	pws_text = ws_text;
}

String sg_st_str(s, prt)
String s;
Int prt;
{	String st;
	st = (String)seg_block(sizeof(char), prt, (strlen(s) + 1));
	strcpy(st, s);
	return(st);
}

/*
sg_txtrect(s, prt)
String	*s;
Int	prt;
{
	Nc	*nc = sg_sp_pr(4, TXT);
}
*/

Bool
ch_in_cliprect(ws, icp, dclip)
Wss *ws;
Ic *icp;
Drect	*dclip;
{	
	return (Bool) (
	    (icp->i_x > (Int)dclip->d_ll.d_x ) &&
	    (icp->i_y > (Int)dclip->d_ll.d_y ) &&
	    (icp->i_x < (Int)dclip->d_ur.d_x - 
				WsScrn->s_chsz.i_x) &&
	    (icp->i_y < (Int)dclip->d_ur.d_y - 
		       		WsScrn->s_chsz.i_y)
	   ) ;
}
